
(defun c:delbow (/ ent_bottom ent_front ss)

  (setq old_cmdecho  (getvar "cmdecho"))
  (setvar "cmdecho" 0)
  (command "_.undo" "be")

  (setq de_oer *error* *error* de_err)
  
  (if (null (rest_dp))
    (rest_dp)
  )

  (setq de_del nil)

  (setq old_osnap    (getvar "osmode"))
  (setq blipmode_old (getvar "blipmode"))
  (setq pickbox_old  (getvar "pickbox"))
  (setq angbase_old  (getvar "angbase"))
  (setq col_old      (getvar "cecolor"))
  (setq celtype_old  (getvar "celtype"))
  (setq lay_old      (getvar "clayer"))
  (setq text_old     (getvar "textstyle"))
  (setq plinewid_old (getvar "plinewid"))
  (setvar "plinewid" 0)
  (setvar "angbase"  0)
  (setvar "blipmode" 0)
  (setvar "pickbox"  0)
  (setvar "celtype" "bylayer")

  (run_de)
    
  (unload_dialog dcl_id)
  (setvar "plinewid"  plinewid_old)
  (setvar "angbase"   angbase_old)
  (setvar "textstyle" text_old)
  (setvar "clayer"    lay_old)
  (setvar "cecolor"   col_old)
  (setvar "celtype"   celtype_old)
  (setvar "osmode"    old_osnap)
  (setvar "blipmode"  blipmode_old)
  (setvar "pickbox"   pickbox_old)
  (setq *error* de_oer)
  (command "_.undo" "end")
  (setvar "cmdecho"   old_cmdecho)
  (princ)
)
;;;================================Run_de=========================================

(defun run_de ()
  
  (setq de_what_next 2)
  
  (while (>= de_what_next 2)
    
        (setq dcl_id (load_dialog "delbow.dcl"))
        (if (not (new_dialog "de" dcl_id))
            (exit)
        )


        (if (null de_shape)
	  (setq de_shape "front")
	)
        (if (null de_dia)
	  (setq de_dia "100")
	)
        (if (null de_rd)
	  (setq de_rd "1")
	)
        (if (null de_pcs)
	  (setq de_pcs "4")
	)
        (if (null de_angle)
	  (setq de_angle "90")
	)
        (if (null de_type)
	  (setq de_type "de_mitered")
	)
        (if (null de_sign)
	  (setq de_sign "de_left")
	)
        (if (null de_heg)
	  (setq de_heg "100")
	)
        (if (null de_piece)
	  (setq de_piece "1")
	)
        (if (null de_lay)
	  (setq de_lay "1")
	)
        (if (null de_pt)
	  (setq de_pt "supply")
	)
        (if (null t_type)
	  (setq t_type "t_txt1")
	)
        (if (null opt_1)
	  (setq opt_1 "1")
	)
        (if (null dp_auto)
	  (setq dp_auto "1")
	)
        (if (null dp_auto)
          (setq dp_auto "1")
        )

        (de_img_fill)
        (mode_de)

        (setq de_dia_old   de_dia
              de_rd_old    de_rd
              de_pcs_old   de_pcs
	      de_angle_old de_angle
	      de_heg_old   de_heg
        )

        (action_tile "de_img_1" "(setq de_shape \"plan\")   (de_img_fill) (mode_de)")
        (action_tile "de_img_2" "(setq de_shape \"front\")  (de_img_fill) (mode_de)")
        (action_tile "de_img_3" "(setq de_shape \"bottom\") (de_img_fill) (mode_de)")
        (action_tile "de_img_4" "(setq de_shape \"elbow\")  (de_img_fill) (mode_de)")
        (action_tile "de_img_5" "(setq de_shape \"pipe\")   (de_img_fill) (mode_de)")

        (action_tile "de_mitered" "(setq de_type \"de_mitered\") (de_img_fill) (mode_de)")    
        (action_tile "de_radius"  "(setq de_type \"de_radius\")  (de_img_fill) (mode_de)")
  
        (action_tile "de_rigth" "(setq de_sign \"de_rigth\") (de_img_fill)")
        (action_tile "de_left"  "(setq de_sign \"de_left\")  (de_img_fill)")

        (action_tile "de_pt1" "(setq de_pt \"supply\")  (eval_de) (de_img_fill)")    
        (action_tile "de_pt2" "(setq de_pt \"exhaust\") (eval_de) (de_img_fill)")

        (action_tile "de_dia" "(setq de_dia (get_tile \"de_dia\"))(setq key_name $key)(check_de)")

        (action_tile "de_heg" "(setq de_heg (get_tile \"de_heg\"))(setq key_name $key)(check_de)")
  
        (action_tile "de_dis" "(done_dialog 3)")

        (action_tile "de_ans" "(done_dialog 4)")

        (action_tile "de_ops" "(done_dialog 7)")

        (action_tile "de_rd" "(setq de_rd (get_tile \"de_rd\"))(setq key_name $key)(check_de)")
    
        (action_tile "de_pcs" "(setq de_pcs (get_tile \"de_pcs\"))(setq key_name $key)(check_de)")

        (action_tile "de_angle" "(setq de_angle $value)(setq key_name $key)(check_de)")

        (action_tile "de_opt" "(setq opt_1 (get_tile \"de_opt\")) (de_img_fill)")

        (action_tile "de_piece" "(setq de_piece (get_tile \"de_piece\")) (mode_de)")

        (action_tile "dp_auto" "(setq dp_auto (get_tile \"dp_auto\"))")

	(action_tile "de_lay"  "(setq de_lay (get_tile \"de_lay\"))")
  
        (set_tile "de_dia"   de_dia)
        (set_tile "de_rd"    de_rd)
        (set_tile "de_pcs"   de_pcs)
        (set_tile "de_opt"   opt_1)
        (set_tile "de_angle" de_angle)
        (set_tile "de_heg"   de_heg)
        (set_tile "de_lay"   de_lay)
        (set_tile "dp_auto"  dp_auto)
        (set_tile "de_piece" de_piece)

        (cond
	  ((= de_pt "supply")  (set_tile "de_pt1" "1"))
	  ((= de_pt "exhaust") (set_tile "de_pt2" "1"))
	)
  
        (cond
	  ((= de_shape "plan")   (set_tile "de_img_1" "1"))
	  ((= de_shape "front")  (set_tile "de_img_2" "1"))
	  ((= de_shape "bottom") (set_tile "de_img_3" "1"))
	  ((= de_shape "elbow")  (set_tile "de_img_4" "1"))
	  ((= de_shape "pipe")   (set_tile "de_img_5" "1"))
	)

        (cond
	  ((= de_type "de_mitered") (set_tile "de_mitered" "1") (set_tile "de_wid" " Width ="))
	  ((= de_type "de_radius")  (set_tile "de_radius" "1")  (set_tile "de_wid" " Diam. ="))
	)
  
        (cond
	  ((= de_sign "de_rigth") (set_tile "de_rigth" "1"))
	  ((= de_sign "de_left")  (set_tile "de_left" "1"))
	)

        (cond
	  ((= t_type "t_txt1") (set_tile "de_wid" " Diam. ="))
	  ((= t_type "t_txt2") (set_tile "de_wid" " Width ="))
	)

        (action_tile "accept" "(done_dialog 1)")
        (action_tile "cancel" "(done_dialog 0)")

        (eval_de)

        (setq de_what_next (start_dialog))

        (if (= de_what_next 1)
            (cond ((= de_shape "plan")   (de_plan_draw))
                  ((= de_shape "front")  (de_front_draw))
                  ((= de_shape "bottom") (de_bottom_draw))
		  ((= de_shape "elbow")  (de_elb))
		  ((= de_shape "pipe")   (de_anl))
            )
        )

        (if (= de_what_next 3) (de_gds))
    
        (if (= de_what_next 0) (princ "\nFunction Cancelled!"))

        (if (= de_what_next 4) (de_ans))

        (if (= de_what_next 7) (dp_opt))
    )
)
;;;====================================mode_de==========================================
(defun mode_de ()

  (cond
    ((and (or (= de_shape "front") (= de_shape "elbow")) (= de_type "de_mitered") (= de_piece "1"))
     (mode_tile "de_angle" 0)
     (mode_tile "de_pcs" 0)
     (mode_tile "de_rigth" 0)
     (mode_tile "de_left" 0)
     (mode_tile "de_heg" 1)
     (mode_tile "de_rd" 0)
    )
    ((and (or (= de_shape "front") (= de_shape "elbow")) (= de_type "de_mitered") (= de_piece "0"))
     (mode_tile "de_angle" 0)
     (mode_tile "de_pcs" 1)
     (mode_tile "de_rigth" 0)
     (mode_tile "de_left" 0)
     (mode_tile "de_heg" 1)
     (mode_tile "de_rd" 0)
    )
    ((and (or (= de_shape "front") (= de_shape "elbow")) (= de_type "de_radius"))
     (mode_tile "de_angle" 0)
     (mode_tile "de_pcs" 1)
     (mode_tile "de_rigth" 0)
     (mode_tile "de_left" 0)
     (mode_tile "de_heg" 1)
     (mode_tile "de_rd" 0)
    )
    ((and (= de_shape "plan") (= de_type "de_mitered") (= de_piece "1"))
     (mode_tile "de_angle" 1)
     (mode_tile "de_pcs" 0)
     (mode_tile "de_rigth" 1)
     (mode_tile "de_left" 1)
     (mode_tile "de_heg" 0)
     (mode_tile "de_rd" 0)
    )
    ((and (= de_shape "plan") (= de_type "de_mitered") (= de_piece "0"))
     (mode_tile "de_angle" 1)
     (mode_tile "de_pcs" 1)
     (mode_tile "de_rigth" 1)
     (mode_tile "de_left" 1)
     (mode_tile "de_heg" 0)
     (mode_tile "de_rd" 0)
    )
    ((and (= de_shape "plan") (= de_type "de_radius"))
     (mode_tile "de_angle" 1)
     (mode_tile "de_pcs" 0)
     (mode_tile "de_rigth" 1)
     (mode_tile "de_left" 1)
     (mode_tile "de_heg" 1)
     (mode_tile "de_rd" 0)
    )
    ((and (= de_shape "bottom") (= de_type "de_mitered") (= de_piece "1"))
     (mode_tile "de_angle" 1)
     (mode_tile "de_pcs" 0)
     (mode_tile "de_rigth" 1)
     (mode_tile "de_left" 1)
     (mode_tile "de_heg" 0)
     (mode_tile "de_rd" 0)
    )
    ((and (= de_shape "bottom") (= de_type "de_mitered") (= de_piece "0"))
     (mode_tile "de_angle" 1)
     (mode_tile "de_pcs" 1)
     (mode_tile "de_rigth" 1)
     (mode_tile "de_left" 1)
     (mode_tile "de_heg" 0)
     (mode_tile "de_rd" 0)
    )
    ((and (= de_shape "bottom") (= de_type "de_radius"))
     (mode_tile "de_angle" 1)
     (mode_tile "de_pcs" 0)
     (mode_tile "de_rigth" 1)
     (mode_tile "de_left" 1)
     (mode_tile "de_heg" 1)
     (mode_tile "de_rd" 0)
    )
    ((and (= de_shape "pipe") (= de_type "de_mitered"))
     (mode_tile "de_angle" 1)
     (mode_tile "de_pcs" 1)
     (mode_tile "de_rigth" 1)
     (mode_tile "de_left" 1)
     (mode_tile "de_heg" 0)
     (mode_tile "de_rd" 1)
    )
    ((and (= de_shape "pipe") (= de_type "de_radius"))
     (mode_tile "de_angle" 1)
     (mode_tile "de_pcs" 1)
     (mode_tile "de_rigth" 1)
     (mode_tile "de_left" 1)
     (mode_tile "de_heg" 1)
     (mode_tile "de_rd" 1)
    )
  )
)
;;;====================================dp_opt==========================================

(defun dp_opt ()
  
  (if (not (new_dialog "dp_opt" dcl_id)) (exit))

  (sup_img)
  (exh_img)
  (scl_img)
  (ecl_img)
  (stl_img)
  (etl_img)
  (sac_img)
  (eac_img)

  (setq sup_lyr_old sup_lyr
	exh_lyr_old exh_lyr
	scl_lyr_old scl_lyr
	ecl_lyr_old ecl_lyr
	stl_lyr_old stl_lyr
	etl_lyr_old etl_lyr
	sac_lyr_old sac_lyr
	eac_lyr_old eac_lyr
	sup_clr_old sup_clr 
	exh_clr_old exh_clr
	scl_clr_old scl_clr
	ecl_clr_old ecl_clr
	stl_clr_old stl_clr
	etl_clr_old etl_clr
	sac_clr_old sac_clr
	eac_clr_old eac_clr
  )

  (action_tile "dp_sav" "(done_dialog 6)")
  (action_tile "dp_can" "(done_dialog 5)")
  
  (action_tile "dp_sup"  "(setq sup_lyr $value)")
  (action_tile "dp_exh"  "(setq exh_lyr $value)")
  (action_tile "dp_scl"  "(setq scl_lyr $value)")
  (action_tile "dp_ecl"  "(setq ecl_lyr $value)")
  (action_tile "dp_stl"  "(setq stl_lyr $value)")
  (action_tile "dp_etl"  "(setq etl_lyr $value)")
  (action_tile "dp_sac"  "(setq sac_lyr $value)")
  (action_tile "dp_eac"  "(setq eac_lyr $value)")
  
  (action_tile "dp_sup_clr"  "(sup_set)")
  (action_tile "dp_exh_clr"  "(exh_set)")
  (action_tile "dp_scl_clr"  "(scl_set)")
  (action_tile "dp_ecl_clr"  "(ecl_set)")
  (action_tile "dp_stl_clr"  "(stl_set)")
  (action_tile "dp_etl_clr"  "(etl_set)")
  (action_tile "dp_sac_clr"  "(sac_set)")
  (action_tile "dp_eac_clr"  "(eac_set)")

  (set_tile "dp_sup"  sup_lyr)
  (set_tile "sup_clr" (itoa sup_clr))
  (set_tile "dp_exh"  exh_lyr)
  (set_tile "exh_clr" (itoa exh_clr))
  (set_tile "dp_scl"  scl_lyr)
  (set_tile "scl_clr" (itoa scl_clr))
  (set_tile "dp_ecl"  ecl_lyr)
  (set_tile "ecl_clr" (itoa ecl_clr))
  (set_tile "dp_stl"  stl_lyr)
  (set_tile "stl_clr" (itoa stl_clr))
  (set_tile "dp_etl"  etl_lyr)
  (set_tile "etl_clr" (itoa etl_clr))
  (set_tile "dp_sac"  sac_lyr)
  (set_tile "sac_clr" (itoa sac_clr))
  (set_tile "dp_eac"  eac_lyr)
  (set_tile "eac_clr" (itoa eac_clr))

  (setq dp_what_next (start_dialog))
  (cond
    ((= dp_what_next 5)(setq sup_lyr sup_lyr_old
	                     exh_lyr exh_lyr_old 
	                     scl_lyr scl_lyr_old 
	                     ecl_lyr ecl_lyr_old 
	                     stl_lyr stl_lyr_old 
	                     etl_lyr etl_lyr_old
			     sac_lyr sac_lyr_old
			     eac_lyr eac_lyr_old
			     sup_clr sup_clr_old
	                     exh_clr exh_clr_old 
	                     scl_clr scl_clr_old 
	                     ecl_clr ecl_clr_old 
	                     stl_clr stl_clr_old 
	                     etl_clr etl_clr_old
			     sac_clr sac_clr_old
			     eac_clr eac_clr_old
                       ))
    ((= dp_what_next 6)(save_dp))
  )
)
;;;================================Error_check=========================================

(defun check_de ()

  (if (<= (atof de_rd) 0.5)
    (progn
      (alert
	"Improper R/D value!
        \nPlease input proper number
        \ngreater than 0.5."
      )
      (setq de_rd de_rd_old)
      (set_tile "de_rd" de_rd)
      (mode_tile key_name 2)
    )
  )
  (if (> (atof de_rd) 10)
    (progn
      (alert
	"Improper R/D value!
        \nPlease input proper number
        \nsmaller than 10."
      )
      (setq de_rd de_rd_old)
      (set_tile "de_rd" de_rd)
      (mode_tile key_name 2)
    )
  )
  (if (< (atof de_pcs) 2)
    (progn
      (alert
	"Improper Piece value!
        \nPlease input proper integer
        \ngreater than 1."
      )
      (setq de_pcs de_pcs_old)
      (set_tile "de_pcs" de_pcs)
      (mode_tile key_name 2)
    )
  )
  (if (> (atof de_pcs) 10)
    (progn
      (alert
        "Improper Piece value!
        \nPlease input proper integer
        \nsmaller than 10."
      )
      (setq de_pcs de_pcs_old)
      (set_tile "de_pcs" de_pcs)
      (mode_tile key_name 2)
    )
  )
  (if (<= (atof de_angle) 0)
    (progn
      (alert
	"Improper Angle value!
        \nAngle must be
	\nmore than 0 deg."
      )
      (setq de_angle de_angle_old)
      (set_tile "de_angle" de_angle)
      (mode_tile key_name 2)
    )
  )
  (if (>= (atof de_angle) 180)
    (progn
      (alert
	"Improper Angle value!
        \nAngle must be
	\nless than 180 deg."
      )
      (setq de_angle de_angle_old)
      (set_tile "de_angle" de_angle)
      (mode_tile key_name 2)
    )
  )
  (if (<= (atof de_heg) 0.0)
    (progn
      (alert
	"Improper Heigth value!
        \nPlease input proper number
        \ngreater than 0."
      )
      (setq de_heg de_heg_old)
      (set_tile "de_heg" de_heg)
      (mode_tile key_name 2)
    )
  )
  (if (<= (atof de_dia) 0.0)
    (progn
      (alert
	"Improper Diam. or Width value!
        \nPlease input proper number
        \ngreater than 0."
      )
      (setq de_dia de_dia_old)
      (set_tile "de_dia" de_dia)
      (mode_tile key_name 2)
    )
  )
)
;;;================================de_plan_draw=========================================

(defun de_plan_draw ()

  (check_eval)

  (setq d   (atof de_dia)
        rd  (atof de_rd)
        pcs (atoi de_pcs)
	heg (atof de_heg)
  )

  (setq de_ip  (getpoint "\nInsertion point : "))

  (cond
    ((= de_ip nil)
     (princ "\nFunction cancelled!")
    )
    ((/= de_ip nil)
     (setq de_br1 (ssget de_ip))

     (cond
       ((and (/= de_br1 nil) (= dp_auto "1") (setq x_list (assoc -3 (entget (ssname de_br1 0) (list "hvac_duct")))))
        (get_base)
        (de_apd)
       )
       ((and (/= de_br1 nil) (= dp_auto "1") (setq x_list (assoc -3 (entget (ssname de_br1 0) (list "hvac_end")))))
	(get_end_base)
	(de_epd)
       )
       (T
	(de_pld)
       )
     )
    )
  )
)
;;;================================de_pld=========================================

(defun de_pld ()

    (setq ang (/ 90.0 (* 2 (- pcs 1))))

    (setq p1 (polar de_ip (dtr 270) (/ d 2.0))
          p2 (polar p1 (dtr 90) d)
          p3 (polar p2 (dtr 0) (* rd d))
          p4 (polar p3 (dtr 270) d)
	  p5 (polar de_ip (dtr 0) (* rd d))
    )

    (cond
      ((= de_type "de_radius")
      
       (setvar "osmode" 0)

       (if (= opt_1 "1")
         (progn
           (setq p6  (polar de_ip (dtr 0)   (* rd d))
                 p7  (polar de_ip (dtr 180) (* 1.5 (/ d 2.0)))
                 p8  (polar de_ip (dtr 90)  (* 1.5 (/ d 2.0)))
                 p9  (polar de_ip (dtr 270) (* 1.5 (/ d 2.0)))
           )
         )
       )
       
          (if (= de_lay "1")
	    (progn
	      (command "_.layer" "m" vp_lyr "s" vp_lyr "")
	      (command "_.color" vp_clr)
	    )
	  )
       
          (command "_.arc" p2 "c" de_ip p1)
          (setq ent_plan (list (entlast)))
       
          (command "_.pline" p1 p4 p3 p2 "")
          (setq ent_plan (append ent_plan (list (entlast))))

          (setq count 1)

          (repeat (- pcs 2)
            (setq count (+ count 2))
            (setq x1 (* (cos (dtr (* count ang))) rd d)
                  x2 (* (cos (dtr (* count ang)))
                        (/ (+ (* rd d) (/ d 2.0)) (cos (dtr ang)))
                     )
            )

            (setq ep1 (polar p5 (dtr 180) x2)
                  ep2 (polar p4 (dtr 180) x1)
                  ep3 (polar p3 (dtr 180) x1)
            )

            (command "_.ellipse" "a" ep3 ep2 ep1 ep3 ep2)
            (setq ent_plan (append ent_plan (list (entlast))))
	  )

       (if (= opt_1 "1")
         (progn
	   (if (= de_lay "1")
	     (progn
               (command "_.layer" "m" cl_lyr "l" "center" cl_lyr "")
	       (command "_.color" cl_clr)
             )
	   )
           (command "_.line" p6 p7 "")
           (setq ent_plan (append ent_plan (list (entlast))))

           (command "_.line" p8 p9 "")
           (setq ent_plan (append ent_plan (list (entlast))))
         )
       )
     )

      ((= de_type "de_mitered")

       (setq p3 (polar p2 (dtr 0) (* rd heg))
             p4 (polar p3 (dtr 270) d)
	     p5 (polar de_ip (dtr 0) (* rd heg))
       )
	
       (setq p10 (polar p2 (dtr 180) (/ heg 2))
	     p11 (polar p1 (dtr 180) (/ heg 2))
       )

       (if (= opt_1 "1")
         (progn
	   (setq de_od (min d heg))
	   
           (setq p6  (polar de_ip (dtr 0)   (* rd d))
                 p7  (polar de_ip (dtr 180) (+ (/ heg 2) (/ de_od 4)))
                 p8  (polar de_ip (dtr 90)  (+ (/ d 2) (/ de_od 4)))
                 p9  (polar de_ip (dtr 270) (+ (/ d 2) (/ de_od 4)))
           )
         )
       )
	 
	 (setvar "osmode" 0)
       
	 (if (= de_lay "1")
	   (progn
             (command "_.layer" "m" vp_lyr "s" vp_lyr "")
	     (command "_.color" vp_clr)
	   )
	 )
	 (command "_.pline" p3 p4 p11 p10 "c")
	 (setq ent_plan (list (entlast)))

         (setq count 1)
       
	 (repeat (- pcs 2)
            (setq count (+ count 2))
            (setq x2 (* (cos (dtr (* count ang)))
                        (/ (+ (* rd heg) (/ heg 2.0)) (cos (dtr ang)))
                     )
            )

            (setq ep1 (polar p5 (dtr 180) x2))
	    (setq ep2 (polar ep1 (dtr 90) (/ d 2.0)))
	    (setq ep3 (polar ep1 (dtr 270) (/ d 2.0)))

            (command "_.line" ep3 ep2 "")
            (setq ent_plan (append ent_plan (list (entlast))))
	 )
       
	 (if (= opt_1 "1")
	   (progn
	     (if (= de_lay "1")
	       (progn
                 (command "_.layer" "m" cl_lyr "l" "center" cl_lyr "")
	         (command "_.color" cl_clr)
	       )
	     )
	     (command "_.line" p5 p7 "")
	     (setq ent_plan (append ent_plan (list (entlast))))
	     (command "_.line" p8 p9 "")
	     (setq ent_plan (append ent_plan (list (entlast))))
	   )
	 )
	)
      )

  (setq lstn (length ent_plan))
  (setq no -1)

  (setq ss (ssadd))
  (repeat lstn
  (setq no (1+ no))
  (ssadd (nth no ent_plan) ss))
      
  (setvar "osmode" old_osnap)
  (command "_.rotate" ss "" de_ip pause)
)
;;;================================de_apd=========================================

(defun de_apd ()

  (setq de_mdl (entget (ssname de_br1 0)))
  (setq de_msp (cdr (assoc 10 de_mdl)))
  (setq de_mep (cdr (assoc 11 de_mdl)))
  (setq de_dsp (distance de_ip de_msp))
  (setq de_dep (distance de_ip de_mep))

  (cond
    ((<= de_dsp de_dep)
     (setq de_ang (angle de_mep de_msp))
     (setq de_ip (polar de_msp dp_mda (/ dp_mds 2.0)))
    )
    ((< de_dep de_dsp)
     (setq de_ang (angle de_msp de_mep))
     (setq de_ip (polar de_mep dp_mda (/ dp_mds 2.0)))
    )
  )

  (setq de_ept (polar de_ip dp_mda (/ dp_mds 4.0)))
  (setq de_er1 (ssget de_ept))

  (setq de_aba (- dp_mda de_ang))

  (if (< de_aba 0) (setq de_aba (+ (* pi 2) de_aba)))

  (setq ang (/ 90.0 (* 2 (- pcs 1))))

  (setq p1 (polar de_ip dp_mda (/ dp_mds 2.0))
        p2 (polar de_ip (+ dp_mda pi) (/ dp_mds 2.0))
        p3 (polar p1 de_ang (* rd dp_mds))
        p4 (polar p2 de_ang (* rd dp_mds))
	p5 (polar de_ip de_ang (* rd dp_mds))
	p10 (polar p5 de_ang (/ dp_mds 2.0))
  )
  
    (cond
      ((= d_type "RND_DUCT")
      
       (setvar "osmode" 0)

       (if (= opt_1 "1")
         (progn
           (setq p6 (polar p5 de_ang (* 1.5 (/ dp_mds 2.0)))
                 p7 (polar p5 (+ dp_mda pi) (* 1.5 (/ dp_mds 2.0)))
                 p8 (polar p5 dp_mda (* 1.5 (/ dp_mds 2.0)))
           )
         )
       )

       (if (and (/= de_er1 nil) (setq x_list (assoc -3 (entget (ssname de_er1 0) (list "hvac_end")))))
	 (setq de_del (entdel (cdr (assoc -1 (entget (ssname de_er1 0))))))
       )
       
       (if (= opt_1 "1")
         (progn
	   (if (= de_lay "1")
	     (progn
                (command "_.layer" "m" cl_lyr "l" "center" cl_lyr "")
	        (command "_.color" cl_clr)
             )
	   ) 
           (command "_.line" de_ip p6 "")
           (command "_.line" p7 p8 "")
         )
       )
       
       (if (= de_lay "1")
	 (progn
	   (command "_.layer" "m" vp_lyr "s" vp_lyr "")
	   (command "_.color" vp_clr)
	 )
       )
       
       (command "_.pline" p4 p2 p1 p3 "")

       (command "_.arc" p4 p10 p3)

          (setq count 1)

          (repeat (- pcs 2)
            (setq count (+ count 2))
            (setq x1 (* (cos (dtr (* count ang))) rd dp_mds)
                  x2 (* (cos (dtr (* count ang)))
                        (/ (+ (* rd dp_mds) (/ dp_mds 2.0)) (cos (dtr ang)))
                     )
            )

            (setq ep1 (polar de_ip de_ang x2)
                  ep2 (polar p1 de_ang x1)
                  ep3 (polar p2 de_ang x1)
            )

	    (cond
              ((and (> de_aba 0) (< de_aba pi))
               (command "_.ellipse" "a" ep3 ep2 ep1 ep3 ep2)
              )
              ((and (> de_aba pi) (< de_aba (* pi 2)))   
               (command "_.ellipse" "a" ep3 ep2 ep1 ep2 ep3)
              )
            )
	  )
      )

      ((= d_type "RECT_DUCT")

       (setq p3 (polar p1 de_ang (* rd dp_mdh))
             p4 (polar p2 de_ang (* rd dp_mdh))
	     p5 (polar de_ip de_ang (* rd dp_mdh))
       )
	
       (setq p3 (polar p3 de_ang (/ dp_mdh 2))
	     p4 (polar p4 de_ang (/ dp_mdh 2))
       )

       (if (= opt_1 "1")
         (progn
	   (setq de_od (min dp_mds dp_mdh))
           (setq p6  (polar p5 de_ang (+ (/ dp_mdh 2) (/ de_od 4)))
                 p7  (polar p5 (+ dp_mda pi) (+ (/ dp_mds 2) (/ de_od 4)))
                 p8  (polar p5 dp_mda (+ (/ dp_mds 2) (/ de_od 4)))
           )
         )
       )
	 
       (setvar "osmode" 0)

       (if (and (/= de_er1 nil) (setq x_list (assoc -3 (entget (ssname de_er1 0) (list "hvac_end")))))
	 (setq de_del (entdel (cdr (assoc -1 (entget (ssname de_er1 0))))))
       )

         (if (= opt_1 "1")
	   (progn
	     (if (= de_lay "1")
	       (progn
                 (command "_.layer" "m" cl_lyr "l" "center" cl_lyr "")
	         (command "_.color" cl_clr)
	       )
	     )
	     (command "_.line" de_ip p6 "")
             (command "_.line" p7 p8 "")
	   )
	 )
       
	 (if (= de_lay "1")
	   (progn
             (command "_.layer" "m" vp_lyr "s" vp_lyr "")
	     (command "_.color" vp_clr)
	   )
	 )
       
	 (command "_.pline" p1 p3 p4 p2 "c")

       (setq count 1)

        (repeat (- pcs 2)
            (setq count (+ count 2))
            (setq x2 (* (cos (dtr (* count ang)))
                        (/ (+ (* rd dp_mdh) (/ dp_mdh 2.0)) (cos (dtr ang)))
                     )
            )

            (setq ep1 (polar de_ip de_ang x2))
	    (setq ep2 (polar ep1 dp_mda (/ dp_mds 2)))
	    (setq ep3 (polar ep1 (+ dp_mda pi) (/ dp_mds 2)))

	    (command "_.line" ep2 ep3 "")
       )
      )
    )
)
;;;================================de_epd=========================================

(defun de_epd ()

  (setq de_ang (+ dp_mda pi))
  (setq de_ip dp_e1)

  (setq ang (/ 90.0 (* 2 (- pcs 1))))

  (setq p1 (polar de_ip (+ de_ang (/ pi 2)) (/ dp_mds 2.0))
        p2 (polar de_ip (- de_ang (/ pi 2)) (/ dp_mds 2.0))
        p3 (polar p1 de_ang (* rd dp_mds))
        p4 (polar p2 de_ang (* rd dp_mds))
	p5 (polar de_ip de_ang (* rd dp_mds))
	p10 (polar p5 de_ang (/ dp_mds 2.0))
  )
  
    (cond
      ((= d_type "RND_DUCT")
      
       (setvar "osmode" 0)

       (if (= opt_1 "1")
         (progn
           (setq p6 (polar p5 de_ang (* 1.5 (/ dp_mds 2.0)))
                 p7 (polar p5 (+ de_ang (/ pi 2)) (* 1.5 (/ dp_mds 2.0)))
                 p8 (polar p5 (- de_ang (/ pi 2)) (* 1.5 (/ dp_mds 2.0)))
           )
         )
       )
       
       (setq de_del (entdel (cdr (assoc -1 (entget (ssname de_br1 0))))))
       
       (if (= opt_1 "1")
         (progn
	   (if (= de_lay "1")
	     (progn
                (command "_.layer" "m" cl_lyr "l" "center" cl_lyr "")
	        (command "_.color" cl_clr)
             )
	   ) 
           (command "_.line" de_ip p6 "")
           (command "_.line" p7 p8 "")
         )
       )
       
       (if (= de_lay "1")
	 (progn
	   (command "_.layer" "m" vp_lyr "s" vp_lyr "")
	   (command "_.color" vp_clr)
	 )
       )
       
       (command "_.pline" p4 p2 p1 p3 "")

       (command "_.arc" p4 p10 p3)

          (setq count 1)

          (repeat (- pcs 2)
            (setq count (+ count 2))
            (setq x1 (* (cos (dtr (* count ang))) rd dp_mds)
                  x2 (* (cos (dtr (* count ang)))
                        (/ (+ (* rd dp_mds) (/ dp_mds 2.0)) (cos (dtr ang)))
                     )
            )

            (setq ep1 (polar de_ip de_ang x2)
                  ep2 (polar p1 de_ang x1)
                  ep3 (polar p2 de_ang x1)
            )

            (command "_.ellipse" "a" ep3 ep2 ep1 ep3 ep2)
	  )
      )

      ((= d_type "RECT_DUCT")

       (setq p3 (polar p1 de_ang (* rd dp_mdh))
             p4 (polar p2 de_ang (* rd dp_mdh))
	     p5 (polar de_ip de_ang (* rd dp_mdh))
       )
	
       (setq p3 (polar p3 de_ang (/ dp_mdh 2))
	     p4 (polar p4 de_ang (/ dp_mdh 2))
       )

       (if (= opt_1 "1")
         (progn
	   (setq de_od (min dp_mds dp_mdh))
           (setq p6  (polar p5 de_ang (+ (/ dp_mdh 2) (/ de_od 4)))
                 p7  (polar p5 (+ de_ang (/ pi 2)) (+ (/ dp_mds 2) (/ de_od 4)))
                 p8  (polar p5 (- de_ang (/ pi 2)) (+ (/ dp_mds 2) (/ de_od 4)))
           )
         )
       )
	 
       (setvar "osmode" 0)

       (setq de_del (entdel (cdr (assoc -1 (entget (ssname de_br1 0))))))

         (if (= opt_1 "1")
	   (progn
	     (if (= de_lay "1")
	       (progn
                 (command "_.layer" "m" cl_lyr "l" "center" cl_lyr "")
	         (command "_.color" cl_clr)
	       )
	     )
	     (command "_.line" de_ip p6 "")
             (command "_.line" p7 p8 "")
	   )
	 )
       
       (if (= de_lay "1")
	 (progn
           (command "_.layer" "m" vp_lyr "s" vp_lyr "")
	   (command "_.color" vp_clr)
	 )
       )
       
       (command "_.pline" p1 p3 p4 p2 "c")

       (setq count 1)

       (repeat (- pcs 2)
         (setq count (+ count 2))
         (setq x2 (* (cos (dtr (* count ang)))
                     (/ (+ (* rd dp_mdh) (/ dp_mdh 2.0)) (cos (dtr ang)))
                  )
         )

         (setq ep1 (polar de_ip de_ang x2))
	 (setq ep2 (polar ep1 (- de_ang (/ pi 2)) (/ dp_mds 2)))
	 (setq ep3 (polar ep1 (+ de_ang (/ pi 2)) (/ dp_mds 2)))

	 (command "_.line" ep2 ep3 "")
       )
      )
  )
)
;;;================================de_bottom_draw=========================================
(defun de_bottom_draw ()

  (check_eval)
  
  (setq d   (atof de_dia)
        rd  (atof de_rd)
        pcs (atoi de_pcs)
        heg (atof de_heg)
  )

  (setq de_ip  (getpoint "\nInsertion point : "))

  (cond
    ((= de_ip nil)
     (princ "\nFunction cancelled!")
    )
    ((/= de_ip nil)
     (setq de_br1 (ssget de_ip))

     (cond
       ((and (/= de_br1 nil) (= dp_auto "1") (setq x_list (assoc -3 (entget (ssname de_br1 0) (list "hvac_duct")))))
        (get_base)
        (de_abd)
       )
       ((and (/= de_br1 nil) (= dp_auto "1") (setq x_list (assoc -3 (entget (ssname de_br1 0) (list "hvac_end")))))
	(get_end_base)
	(de_ebd)
       )
       (T
	(de_bld)
       )
     )
    )
  )
)
;;;================================de_bld=========================================

(defun de_bld ()

  (setq p1 (polar de_ip (dtr 270) (/ d 2.0))
        p2 (polar de_ip (dtr 90) (/ d 2.0))
        p3 (polar p2 (dtr 0) (* rd d))
        p4 (polar p1 (dtr 0) (* rd d))
	p5 (polar de_ip (dtr 0) (* rd d))
  )

  (setq ang (/ 90.0 (* 2 (- pcs 1))))

  (cond
    ((= de_type "de_radius")

       (if (= opt_1 "1")
         (progn
           (setq p6 (polar de_ip (dtr 0) (* rd d))
                 p7 (polar de_ip (dtr 180) (* 1.5 (/ d 2.0)))
                 p8 (polar de_ip (dtr 90) (* 1.5 (/ d 2.0)))
                 p9 (polar de_ip (dtr 270) (* 1.5 (/ d 2.0)))
           )
         )
       )
       
       (setvar "osmode" 0)
       (if (= de_lay "1")
	 (progn
           (command "_.layer" "m" vp_lyr "s" vp_lyr "")
	   (command "_.color" vp_clr)
	 )
       )

       (command "_.circle" de_ip p1)
       (setq ent_bottom (list (entlast)))

       (if (= opt_1 "1")
           (progn
	       (if (= de_lay "1")
		 (progn
                   (command "_.layer" "m" cl_lyr "l" "center" cl_lyr "")
	           (command "_.color" cl_clr)
		 )
	       )
               (command "_.line" p6 p7 "")
               (setq ent_bottom (append ent_bottom (list (entlast))))
               (command "_.line" p8 p9 "")
               (setq ent_bottom (append ent_bottom (list (entlast))))
           )
       )
       
       (if (= de_lay "1")
	 (progn
           (command "_.layer" "m" vp_lyr "s" vp_lyr "")
	   (command "_.color" vp_clr)
	 )
       )
       
       (command "_.pline" p1 p4 p3 p2 "")
       (setq ent_bottom (append ent_bottom (list (entlast))))

       (setq count 1)
       (repeat (- pcs 2)
           (setq count (+ count 2))

           (setq x1 (- (* rd d)
                       (/ (* (cos (dtr (* count ang)))
                             (- (* rd d) (/ d 2.0))
                          )
                          (cos (dtr ang))
                       )
                    )
                 x2 (- (* rd d) (* (cos (dtr (* count ang))) (* rd d)))
           )

           (setq ep1 (polar de_ip (dtr 0) x1)
                 ep2 (polar p1 (dtr 0) x2)
                 ep3 (polar p2 (dtr 0) x2)
           )
           (command "_.ellipse" "a" ep2 ep3 ep1 ep2 ep3)
           (setq ent_bottom (append ent_bottom (list (entlast))))
       )
       
       (setq lstn (length ent_bottom))
       (setq no -1)
       (setq ss (ssadd))
       (repeat lstn
           (setq no (1+ no))
           (ssadd (nth no ent_bottom) ss)
       )
       (setvar "osmode" old_osnap)
       (command "_.rotate" ss "" de_ip pause)
     )
    
    ((= de_type "de_mitered")

       (setq p3 (polar p2 (dtr 0) (* rd heg))
             p4 (polar p1 (dtr 0) (* rd heg))
             p5 (polar de_ip (dtr 0) (* rd heg))
       )

       (setq p10 (polar p2 (dtr 180) (/ heg 2))
	     p11 (polar p2 (dtr 0) (/ heg 2))
	     p12 (polar p1 (dtr 180) (/ heg 2))
	     p13 (polar p1 (dtr 0) (/ heg 2))
       )

       (if (= opt_1 "1")
         (progn
	   (setq de_od (min d heg))
	   
           (setq p6  (polar de_ip (dtr 0)   (* rd heg))
                 p7  (polar de_ip (dtr 180) (+ (/ heg 2) (/ de_od 4)))
                 p8  (polar de_ip (dtr 90)  (+ (/ d 2) (/ de_od 4)))
                 p9  (polar de_ip (dtr 270) (+ (/ d 2) (/ de_od 4)))
           )
         )
       )
       
       (setvar "osmode" 0)
       
       (if (= de_lay "1")
	 (progn
           (command "_.layer" "m" vp_lyr "s" vp_lyr "")
	   (command "_.color" vp_clr)
	 )
       )
       
       (command "_.pline" p3 p4 p12 p10 "c")
       (setq ent_plan (list (entlast)))
       (command "_.line" p11 p13 "")
       (setq ent_plan (append ent_plan (list (entlast))))

       (setq count 1)
       (repeat (- pcs 2)
	 
         (setq count (+ count 2))

         (setq x1 (- (* rd heg)
                     (/ (* (cos (dtr (* count ang)))
                           (- (* rd heg) (/ heg 2.0))
                        )
                        (cos (dtr ang))
                     )
                  )
         )

         (setq ep1 (polar de_ip (dtr 0) x1)
               ep2 (polar ep1 (dtr 90) (/ d 2.0))
               ep3 (polar ep1 (dtr 270) (/ d 2.0))
         )
	 
         (command "_.line" ep2 ep3 "")
         (setq ent_plan (append ent_plan (list (entlast))))
       )
       
       	 (if (= opt_1 "1")
	   (progn
	     (if (= de_lay "1")
	       (progn
                 (command "_.layer" "m" cl_lyr "l" "center" cl_lyr "")
	         (command "_.color" cl_clr)
	       )
	     )
	     (command "_.line" p6 p7 "")
	     (setq ent_plan (append ent_plan (list (entlast))))
	     (command "_.line" p8 p9 "")
	     (setq ent_plan (append ent_plan (list (entlast))))
	   )
	 )

	 (setq lstn (length ent_plan))
         (setq no -1)

         (setq ss (ssadd))
         (repeat lstn
           (setq no (1+ no))
           (ssadd (nth no ent_plan) ss)
         )
         (setvar "osmode" old_osnap)
         (command "_.rotate" ss "" de_ip pause)
       )
    )    
)
;;;================================de_abd=========================================

(defun de_abd ()

  (setq de_mdl (entget (ssname de_br1 0)))
  (setq de_msp (cdr (assoc 10 de_mdl)))
  (setq de_mep (cdr (assoc 11 de_mdl)))
  (setq de_dsp (distance de_ip de_msp))
  (setq de_dep (distance de_ip de_mep))

  (cond
    ((<= de_dsp de_dep)
     (setq de_ang (angle de_mep de_msp))
     (setq de_ip (polar de_msp dp_mda (/ dp_mds 2.0)))
    )
    ((< de_dep de_dsp)
     (setq de_ang (angle de_msp de_mep))
     (setq de_ip (polar de_mep dp_mda (/ dp_mds 2.0)))
    )
  )

  (setq de_ept (polar de_ip dp_mda (/ dp_mds 4.0)))
  (setq de_er1 (ssget de_ept))

  (setq de_aba (- dp_mda de_ang))

  (if (< de_aba 0) (setq de_aba (+ (* pi 2) de_aba)))

  (setq ang (/ 90.0 (* 2 (- pcs 1))))

  (setq p1 (polar de_ip dp_mda (/ dp_mds 2.0))
        p2 (polar de_ip (+ dp_mda pi) (/ dp_mds 2.0))
        p3 (polar p1 de_ang (* rd dp_mds))
        p4 (polar p2 de_ang (* rd dp_mds))
	p5 (polar de_ip de_ang (* rd dp_mds))
	p10 (polar p5 de_ang (/ dp_mds 2.0))
  )
  
    (cond
      ((= d_type "RND_DUCT")
      
       (setvar "osmode" 0)

       (if (= opt_1 "1")
         (progn
           (setq p6 (polar p5 de_ang (* 1.5 (/ dp_mds 2.0)))
                 p7 (polar p5 (+ dp_mda pi) (* 1.5 (/ dp_mds 2.0)))
                 p8 (polar p5 dp_mda (* 1.5 (/ dp_mds 2.0)))
           )
         )
       )

       (if (and (/= de_er1 nil) (setq x_list (assoc -3 (entget (ssname de_er1 0) (list "hvac_end")))))
	 (setq de_del (entdel (cdr (assoc -1 (entget (ssname de_er1 0))))))
       )
       
       (if (= opt_1 "1")
         (progn
	   (if (= de_lay "1")
	     (progn
                (command "_.layer" "m" cl_lyr "l" "center" cl_lyr "")
	        (command "_.color" cl_clr)
             )
	   ) 
           (command "_.line" de_ip p6 "")
           (command "_.line" p7 p8 "")
         )
       )
       
       (if (= de_lay "1")
	 (progn
	   (command "_.layer" "m" vp_lyr "s" vp_lyr "")
	   (command "_.color" vp_clr)
	 )
       )
       
       (command "_.pline" p4 p2 p1 p3 "")

       (command "_.circle" p5 p10)

          (setq count 1)

          (repeat (- pcs 2)
            (setq count (+ count 2))
            (setq x1 (* (cos (dtr (* count ang))) rd dp_mds)
                  x2 (* (cos (dtr (* count ang)))
                        (/ (+ (* rd dp_mds) (/ dp_mds 2.0)) (cos (dtr ang)))
                     )
            )

            (setq ep1 (polar de_ip de_ang x2)
                  ep2 (polar p1 de_ang x1)
                  ep3 (polar p2 de_ang x1)
            )

	    (cond
              ((and (> de_aba 0) (< de_aba pi))
               (command "_.ellipse" "a" ep3 ep2 ep1 ep2 ep3)
              )
              ((and (> de_aba pi) (< de_aba (* pi 2)))   
               (command "_.ellipse" "a" ep3 ep2 ep1 ep3 ep2)
              )
            )
	  )
      )

      ((= d_type "RECT_DUCT")

       (setq p3 (polar p1 de_ang (* rd dp_mdh))
             p4 (polar p2 de_ang (* rd dp_mdh))
	     p5 (polar de_ip de_ang (* rd dp_mdh))
       )
	
       (setq p9 (polar p3 (+ de_ang pi) (/ dp_mdh 2))
	     p10 (polar p4 (+ de_ang pi) (/ dp_mdh 2))
	     p3 (polar p3 de_ang (/ dp_mdh 2))
	     p4 (polar p4 de_ang (/ dp_mdh 2))
       )

       (if (= opt_1 "1")
         (progn
	   (setq de_od (min dp_mds dp_mdh))  
           (setq p6  (polar p5 de_ang (+ (/ dp_mdh 2) (/ de_od 4)))
                 p7  (polar p5 (+ dp_mda pi) (+ (/ dp_mds 2) (/ de_od 4)))
                 p8  (polar p5 dp_mda (+ (/ dp_mds 2) (/ de_od 4)))
           )
         )
       )
	 
       (setvar "osmode" 0)

       (if (and (/= de_er1 nil) (setq x_list (assoc -3 (entget (ssname de_er1 0) (list "hvac_end")))))
	 (setq de_del (entdel (cdr (assoc -1 (entget (ssname de_er1 0))))))
       )

       (if (= opt_1 "1")
	 (progn
	   (if (= de_lay "1")
	     (progn
               (command "_.layer" "m" cl_lyr "l" "center" cl_lyr "")
	       (command "_.color" cl_clr)
	     )
	   )
	   (command "_.line" de_ip p6 "")
           (command "_.line" p7 p8 "")
	 )
       )
       
       (if (= de_lay "1")
	 (progn
           (command "_.layer" "m" vp_lyr "s" vp_lyr "")
	   (command "_.color" vp_clr)
	 )
       )
       
       (command "_.pline" p1 p3 p4 p2 "c")

       (command "_.pline" p9 p10 "")

       (setq count 1)

       (repeat (- pcs 2)
	  
         (setq count (+ count 2))
	 
	 (setq x1 (- (* rd dp_mdh)
                     (/ (* (cos (dtr (* count ang)))
                           (- (* rd dp_mdh) (/ dp_mdh 2.0))
                        )
                        (cos (dtr ang))
                     )
                  )
         )

         (setq ep1 (polar p5 (+ de_ang pi) x1))
	 (setq ep2 (polar ep1 dp_mda (/ dp_mds 2)))
	 (setq ep3 (polar ep1 (+ dp_mda pi) (/ dp_mds 2)))

	 (command "_.line" ep2 ep3 "")
       )
      )
  )
)
;;;================================de_ebd=========================================

(defun de_ebd ()

  (setq de_ang (+ dp_mda pi))
  (setq de_ip dp_e1)

  (setq ang (/ 90.0 (* 2 (- pcs 1))))

  (setq p1 (polar de_ip (+ de_ang (/ pi 2)) (/ dp_mds 2.0))
        p2 (polar de_ip (- de_ang (/ pi 2)) (/ dp_mds 2.0))
        p3 (polar p1 de_ang (* rd dp_mds))
        p4 (polar p2 de_ang (* rd dp_mds))
	p5 (polar de_ip de_ang (* rd dp_mds))
	p10 (polar p5 de_ang (/ dp_mds 2.0))
  )
  
    (cond
      ((= d_type "RND_DUCT")
      
       (setvar "osmode" 0)

       (if (= opt_1 "1")
         (progn
           (setq p6 (polar p5 de_ang (* 1.5 (/ dp_mds 2.0)))
                 p7 (polar p5 (+ de_ang (/ pi 2)) (* 1.5 (/ dp_mds 2.0)))
                 p8 (polar p5 (- de_ang (/ pi 2)) (* 1.5 (/ dp_mds 2.0)))
           )
         )
       )
       
       (setq de_del (entdel (cdr (assoc -1 (entget (ssname de_br1 0))))))
       
       (if (= opt_1 "1")
         (progn
	   (if (= de_lay "1")
	     (progn
                (command "_.layer" "m" cl_lyr "l" "center" cl_lyr "")
	        (command "_.color" cl_clr)
             )
	   ) 
           (command "_.line" de_ip p6 "")
           (command "_.line" p7 p8 "")
         )
       )
       
       (if (= de_lay "1")
	 (progn
	   (command "_.layer" "m" vp_lyr "s" vp_lyr "")
	   (command "_.color" vp_clr)
	 )
       )
       
       (command "_.pline" p4 p2 p1 p3 "")

       (command "_.circle" p5 p10)

          (setq count 1)

          (repeat (- pcs 2)
            (setq count (+ count 2))
            (setq x1 (* (cos (dtr (* count ang))) rd dp_mds)
                  x2 (* (cos (dtr (* count ang)))
                        (/ (+ (* rd dp_mds) (/ dp_mds 2.0)) (cos (dtr ang)))
                     )
            )

            (setq ep1 (polar de_ip de_ang x2)
                  ep2 (polar p1 de_ang x1)
                  ep3 (polar p2 de_ang x1)
            )

            (command "_.ellipse" "a" ep3 ep2 ep1 ep2 ep3)
	  )
      )

      ((= d_type "RECT_DUCT")

       (setq p3 (polar p1 de_ang (* rd dp_mdh))
             p4 (polar p2 de_ang (* rd dp_mdh))
	     p5 (polar de_ip de_ang (* rd dp_mdh))
       )
	
       (setq p9 (polar p3 (+ de_ang pi) (/ dp_mdh 2))
	     p10 (polar p4 (+ de_ang pi) (/ dp_mdh 2))
	     p3 (polar p3 de_ang (/ dp_mdh 2))
	     p4 (polar p4 de_ang (/ dp_mdh 2))
       )

       (if (= opt_1 "1")
         (progn
	   (setq de_od (min dp_mds dp_mdh))  
           (setq p6  (polar p5 de_ang (+ (/ dp_mdh 2) (/ de_od 4)))
                 p7  (polar p5 (+ de_ang (/ pi 2)) (+ (/ dp_mds 2) (/ de_od 4)))
                 p8  (polar p5 (- de_ang (/ pi 2)) (+ (/ dp_mds 2) (/ de_od 4)))
           )
         )
       )
	 
       (setvar "osmode" 0)

       (if (= opt_1 "1")
	 (progn
	   (if (= de_lay "1")
	     (progn
               (command "_.layer" "m" cl_lyr "l" "center" cl_lyr "")
	       (command "_.color" cl_clr)
	     )
	   )
	   (command "_.line" de_ip p6 "")
           (command "_.line" p7 p8 "")
	 )
       )
       
       (if (= de_lay "1")
	 (progn
           (command "_.layer" "m" vp_lyr "s" vp_lyr "")
	   (command "_.color" vp_clr)
	 )
       )
       
       (command "_.pline" p1 p3 p4 p2 "c")

       (command "_.pline" p9 p10 "")

       (setq count 1)

       (repeat (- pcs 2)
	  
         (setq count (+ count 2))
	 
	 (setq x1 (- (* rd dp_mdh)
                     (/ (* (cos (dtr (* count ang)))
                           (- (* rd dp_mdh) (/ dp_mdh 2.0))
                        )
                        (cos (dtr ang))
                     )
                  )
         )

         (setq ep1 (polar p5 (+ de_ang pi) x1))
	 (setq ep2 (polar ep1 (- de_ang (/ pi 2)) (/ dp_mds 2)))
	 (setq ep3 (polar ep1 (+ de_ang (/ pi 2)) (/ dp_mds 2)))

	 (command "_.line" ep2 ep3 "")
       )
      )
  )
)
;;;================================de_front_draw=========================================
(defun de_front_draw ()

  (check_eval)
  
  (setq d   (atof de_dia)
        rd  (atof de_rd)
        pcs (atoi de_pcs)
        heg (atof de_heg)
	de_ang (atof de_angle)
  )

  (setq de_ip  (getpoint "\nInsertion point : "))

  (cond
    ((= de_ip nil)
     (princ "\nFunction cancelled!")
    )
    ((/= de_ip nil)
     (setq de_br1 (ssget de_ip))

     (cond
       ((and (/= de_br1 nil) (= dp_auto "1") (setq x_list (assoc -3 (entget (ssname de_br1 0) (list "hvac_duct")))))
        (get_base)
        (de_afd)
       )
       ((and (/= de_br1 nil) (= dp_auto "1") (setq x_list (assoc -3 (entget (ssname de_br1 0) (list "hvac_end")))))
	(get_end_base)
	(de_efd)
       )
       (T
	(de_fld)
       )
     )
    )
  )
)
;;;================================de_afd=========================================

(defun de_afd ()

  (setq de_mdl (entget (ssname de_br1 0)))
  (setq de_msp (cdr (assoc 10 de_mdl)))
  (setq de_mep (cdr (assoc 11 de_mdl)))
  (setq de_dsp (distance de_ip de_msp))
  (setq de_dep (distance de_ip de_mep))

  (cond
    ((<= de_dsp de_dep)
     (setq de_ang1 (angle de_msp de_mep))
     (setq de_ip (polar de_msp dp_mda (/ dp_mds 2.0)))
    )
    ((< de_dep de_dsp)
     (setq de_ang1 (angle de_mep de_msp))
     (setq de_ip (polar de_mep dp_mda (/ dp_mds 2.0)))
    )
  )

  (setq de_ept (polar de_ip dp_mda (/ dp_mds 4.0)))
  (setq de_er1 (ssget de_ept))
  
  (cond
    ((= de_sign "de_rigth")
     (if (and (<= de_ang1 (/ pi 2)) (< (* pi 1.5)))
       (progn
	 (setq znak     +)
	 (setq znak_obr -)
       )
       (progn
	 (setq znak     -)
	 (setq znak_obr +)
       )
     )
    )
    ((= de_sign "de_left")
     (if (and (<= de_ang1 (/ pi 2)) (< (* pi 1.5)))
       (progn
         (setq znak     -)
         (setq znak_obr +)
       )
       (progn
	 (setq znak     +)
	 (setq znak_obr -)
       )
      )
    )
  )

  (setq de_ang (dtr de_ang))

  (if (= de_piece "0")
    (progn
      (cond
	((<= de_ang (/ pi 6))
	 (setq pcs 2)
	)
	((and (>= de_ang (/ pi 6)) (<= de_ang (/ pi 3)))
	 (setq pcs 3)
	)
	((and (> de_ang (/ pi 3)) (< de_ang (/ pi 1.5)))
	 (setq pcs 4)
	)
	((and (>= de_ang (/ pi 1.5)) (< de_ang (/ (* pi 5) 6)))
	 (setq pcs 5)
	)
	((> de_ang (/ (* pi 5) 6))
	 (setq pcs 7)
	)
      )
    )
  )

  (setq ang   (/ de_ang (* 2 (- pcs 1)))
        dist1 (* (+ (* rd dp_mds) (/ dp_mds 2.0)) (tan ang))
        dist2 (* (- (* rd dp_mds) (/ dp_mds 2.0)) (tan ang))
	dist3 (* (* rd dp_mds) (tan ang))
  )

  (setq p1_temp de_ip
        p1      (polar p1_temp (znak de_ang1 (/ pi 2)) (/ dp_mds 2.0))
        p2      (polar p1 (znak de_ang1 pi) dist1)
        p3      (polar p1 (znak_obr de_ang1 (/ pi 2)) dp_mds)
        p4      (polar p3 (znak de_ang1 pi) dist2)
	p12     (polar p1_temp (znak de_ang1 pi) dist3)

        p9      (polar p1_temp (znak_obr de_ang1 (/ pi 2)) (* rd dp_mds))
        p5_temp (polar p9 (znak (angle p9 p1_temp) de_ang) (* rd dp_mds))
        p5      (polar p5_temp (angle p9 p5_temp) (/ dp_mds 2.0))
        p6      (polar p5 (znak (angle p5_temp p9) (/ pi 2)) dist1)
        p7      (polar p5 (angle p5_temp p9) dp_mds)
        p8      (polar p7 (znak (angle p5_temp p9) (/ pi 2)) dist2)
        p5_temp_dir (polar p5_temp (znak (angle p5_temp p9) (dtr 90)) 5)
        p5_dir  (polar p5 (znak (angle p5_temp p9) (/ pi 2)) 5)
        p7_dir  (polar p7 (znak (angle p5_temp p9) (/ pi 2)) 5)
	p14     (polar p5_temp (znak (angle p5_temp p9) (/ pi 2)) dist3)
  )
;;;=================================Radius=======================================

  (cond
    ((= de_type "de_radius")
     
     (setvar "osmode" 0)
     
     (if (= de_lay "1")
       (progn
         (command "_.layer" "_m" vp_lyr "_s" vp_lyr "")
	 (command "_.color" vp_clr)
       )
     )
     
     (if (= de_lay "1")
       (progn
         (command "_.layer" "_m" vp_lyr "_s" vp_lyr "")
	 (command "_.color" vp_clr)
       )
     )
  
     (command "_.line" p7 p5 "")
     (command "_.arc" p5 "_e" p1 "_d" p5_dir)
     (command "_.arc" p7 "_e" p3 "_d" p7_dir)
     (command "_.line" p3 p1 "") 
  
     (if (= opt_1 "1")
       (progn
	 (if (= de_lay "1")
           (progn
             (command "_.layer" "_m" cl_lyr "_l" "center" cl_lyr "")
	     (command "_.color" cl_clr)
           )
         )
         (command "_.arc" p5_temp "_e" p1_temp "_d" p5_temp_dir)
       )
     )
    )	  
;;;===============================Mitered===================================

    ((= de_type "de_mitered")
     
     (command "_.undo" "_group")
     (setvar "osmode" 0)
  
     (if (= de_lay "1")
       (progn
         (command "_.layer" "_m" vp_lyr "_s" vp_lyr "")
	 (command "_.color" vp_clr)
       )
     )

     (command "_.line" p1 p3 "")
     (command "_.line" p1 p2 "")
     (command "_.line" p3 p4 "")
     (command "_.line" p2 p4 "")
  
     (setq gross_ang (znak de_ang1 pi))
     (repeat (- pcs 2)
       (setq gross_ang (znak gross_ang (* 2.0 ang)))
       (setq p10 (polar p2 gross_ang (* 2.0 dist1)))
       (setq p11 (polar p4 gross_ang (* 2.0 dist2)))
       (command "_.line" p2  p10 "")
       (command "_.line" p4  p11 "")
       (command "_.line" p10 p11 "")
       (setq p2 p10)
       (setq p4 p11)
     )

     (if (= opt_1 "1")
       (progn
	 (if (= de_lay "1")
           (progn
             (command "_.layer" "_m" cl_lyr "_l" "center" cl_lyr "")
	     (command "_.color" cl_clr)
           )
         )
         (command "_.line" p1_temp p12 "")
	 (setq gross_ang (znak de_ang1 pi))
         (repeat (- pcs 2)
           (setq gross_ang (znak gross_ang (* 2.0 ang)))
           (setq p13 (polar p12 gross_ang (* 2.0 dist3)))
           (command "_.line" p12 p13 "")
           (setq p12 p13)
         )
	 (command "_.line" p14 p5_temp "")
       )
     )
     
     (if (= de_lay "1")
       (progn
         (command "_.layer" "_m" vp_lyr "_s" vp_lyr "")
	 (command "_.color" vp_clr)
       )
     )
    
     (command "_.line" p6 p5 "")
     (command "_.line" p8 p7 "")
     (command "_.line" p5 p7 "")     
    )
  )

  (if (and (/= de_er1 nil) (setq x_list (assoc -3 (entget (ssname de_er1 0) (list "hvac_end")))))
    (setq de_del (entdel (cdr (assoc -1 (entget (ssname de_er1 0))))))
  )
)
;;;================================de_efd=========================================

(defun de_efd ()

  (setq de_ang1 dp_mda)
  (setq de_ip dp_e1)
  
  (cond
    ((= de_sign "de_rigth")
     (if (and (<= de_ang1 (/ pi 2)) (< (* pi 1.5)))
       (progn
	 (setq znak     +)
	 (setq znak_obr -)
       )
       (progn
	 (setq znak     -)
	 (setq znak_obr +)
       )
     )
    )
    ((= de_sign "de_left")
     (if (and (<= de_ang1 (/ pi 2)) (< (* pi 1.5)))
       (progn
         (setq znak     -)
         (setq znak_obr +)
       )
       (progn
	 (setq znak     +)
	 (setq znak_obr -)
       )
      )
    )
  )

  (setq de_ang (dtr de_ang))

  (if (= de_piece "0")
    (progn
      (cond
	((<= de_ang (/ pi 6))
	 (setq pcs 2)
	)
	((and (>= de_ang (/ pi 6)) (<= de_ang (/ pi 3)))
	 (setq pcs 3)
	)
	((and (> de_ang (/ pi 3)) (< de_ang (/ pi 1.5)))
	 (setq pcs 4)
	)
	((and (>= de_ang (/ pi 1.5)) (< de_ang (/ (* pi 5) 6)))
	 (setq pcs 5)
	)
	((> de_ang (/ (* pi 5) 6))
	 (setq pcs 7)
	)
      )
    )
  )

  (setq ang   (/ de_ang (* 2 (- pcs 1)))
        dist1 (* (+ (* rd dp_mds) (/ dp_mds 2.0)) (tan ang))
        dist2 (* (- (* rd dp_mds) (/ dp_mds 2.0)) (tan ang))
	dist3 (* (* rd dp_mds) (tan ang))
  )

  (setq p1_temp de_ip
        p1      (polar p1_temp (znak de_ang1 (/ pi 2)) (/ dp_mds 2.0))
        p2      (polar p1 (znak de_ang1 pi) dist1)
        p3      (polar p1 (znak_obr de_ang1 (/ pi 2)) dp_mds)
        p4      (polar p3 (znak de_ang1 pi) dist2)
	p12     (polar p1_temp (znak de_ang1 pi) dist3)

        p9      (polar p1_temp (znak_obr de_ang1 (/ pi 2)) (* rd dp_mds))
        p5_temp (polar p9 (znak (angle p9 p1_temp) de_ang) (* rd dp_mds))
        p5      (polar p5_temp (angle p9 p5_temp) (/ dp_mds 2.0))
        p6      (polar p5 (znak (angle p5_temp p9) (/ pi 2)) dist1)
        p7      (polar p5 (angle p5_temp p9) dp_mds)
        p8      (polar p7 (znak (angle p5_temp p9) (/ pi 2)) dist2)
        p5_temp_dir (polar p5_temp (znak (angle p5_temp p9) (dtr 90)) 5)
        p5_dir  (polar p5 (znak (angle p5_temp p9) (/ pi 2)) 5)
        p7_dir  (polar p7 (znak (angle p5_temp p9) (/ pi 2)) 5)
	p14     (polar p5_temp (znak (angle p5_temp p9) (/ pi 2)) dist3)
  )
;;;=================================Radius=======================================

  (cond
    ((= de_type "de_radius")
     
     (setvar "osmode" 0)

     (setq de_del (entdel (cdr (assoc -1 (entget (ssname de_br1 0))))))
     
     (if (= de_lay "1")
       (progn
         (command "_.layer" "_m" vp_lyr "_s" vp_lyr "")
	 (command "_.color" vp_clr)
       )
     )
     
     (if (= de_lay "1")
       (progn
         (command "_.layer" "_m" vp_lyr "_s" vp_lyr "")
	 (command "_.color" vp_clr)
       )
     )
  
     (command "_.line" p7 p5 "")
     (command "_.arc" p5 "_e" p1 "_d" p5_dir)
     (command "_.arc" p7 "_e" p3 "_d" p7_dir)
     (command "_.line" p3 p1 "") 
  
     (if (= opt_1 "1")
       (progn
	 (if (= de_lay "1")
           (progn
             (command "_.layer" "_m" cl_lyr "_l" "center" cl_lyr "")
	     (command "_.color" cl_clr)
           )
         )
         (command "_.arc" p5_temp "_e" p1_temp "_d" p5_temp_dir)
       )
     )
    )	  
;;;===============================Mitered===================================

    ((= de_type "de_mitered")
     
     (command "_.undo" "_group")
     (setvar "osmode" 0)

     (setq de_del (entdel (cdr (assoc -1 (entget (ssname de_br1 0))))))
  
     (if (= de_lay "1")
       (progn
         (command "_.layer" "_m" vp_lyr "_s" vp_lyr "")
	 (command "_.color" vp_clr)
       )
     )

     (command "_.line" p1 p3 "")
     (command "_.line" p1 p2 "")
     (command "_.line" p3 p4 "")
     (command "_.line" p2 p4 "")
  
     (setq gross_ang (znak de_ang1 pi))
     (repeat (- pcs 2)
       (setq gross_ang (znak gross_ang (* 2.0 ang)))
       (setq p10 (polar p2 gross_ang (* 2.0 dist1)))
       (setq p11 (polar p4 gross_ang (* 2.0 dist2)))
       (command "_.line" p2  p10 "")
       (command "_.line" p4  p11 "")
       (command "_.line" p10 p11 "")
       (setq p2 p10)
       (setq p4 p11)
     )

     (if (= opt_1 "1")
       (progn
	 (if (= de_lay "1")
           (progn
             (command "_.layer" "_m" cl_lyr "_l" "center" cl_lyr "")
	     (command "_.color" cl_clr)
           )
         )
         (command "_.line" p1_temp p12 "")
	 (setq gross_ang (znak de_ang1 pi))
         (repeat (- pcs 2)
           (setq gross_ang (znak gross_ang (* 2.0 ang)))
           (setq p13 (polar p12 gross_ang (* 2.0 dist3)))
           (command "_.line" p12 p13 "")
           (setq p12 p13)
         )
	 (command "_.line" p14 p5_temp "")
       )
     )
     
     (if (= de_lay "1")
       (progn
         (command "_.layer" "_m" vp_lyr "_s" vp_lyr "")
	 (command "_.color" vp_clr)
       )
     )
    
     (command "_.line" p6 p5 "")
     (command "_.line" p8 p7 "")
     (command "_.line" p5 p7 "")     
    )
  )
)
;;;================================de_fld=========================================

(defun de_fld ()

  (setq de_ang1 (* pi 1.5))
  
  (cond
    ((= de_sign "de_rigth")
     (setq znak     -)
     (setq znak_obr +)
    )
    ((= de_sign "de_left")
     (setq znak     +)
     (setq znak_obr -)
    )
  )

  (setq de_ang (dtr de_ang))

  (if (= de_piece "0")
    (progn
      (cond
	((<= de_ang (/ pi 6))
	 (setq pcs 2)
	)
	((and (>= de_ang (/ pi 6)) (<= de_ang (/ pi 3)))
	 (setq pcs 3)
	)
	((and (> de_ang (/ pi 3)) (< de_ang (/ pi 1.5)))
	 (setq pcs 4)
	)
	((and (>= de_ang (/ pi 1.5)) (< de_ang (/ (* pi 5) 6)))
	 (setq pcs 5)
	)
	((> de_ang (/ (* pi 5) 6))
	 (setq pcs 7)
	)
      )
    )
  )

  (setq ang   (/ de_ang (* 2 (- pcs 1)))
        dist1 (* (+ (* rd d) (/ d 2.0)) (tan ang))
        dist2 (* (- (* rd d) (/ d 2.0)) (tan ang))
	dist3 (* (* rd d) (tan ang))
  )

  (setq p1_temp (polar de_ip de_ang1 (* (* rd d) (tan (/ de_ang 2))))
        p1      (polar p1_temp (znak de_ang1 (/ pi 2)) (/ d 2.0))
        p2      (polar p1 (znak de_ang1 pi) dist1)
        p3      (polar p1 (znak_obr de_ang1 (/ pi 2)) d)
        p4      (polar p3 (znak de_ang1 pi) dist2)
	p12     (polar p1_temp (znak de_ang1 pi) dist3)

        p9      (polar p1_temp (znak_obr de_ang1 (/ pi 2)) (* rd d))
        p5_temp (polar p9 (znak (angle p9 p1_temp) de_ang) (* rd d))
        p5      (polar p5_temp (angle p9 p5_temp) (/ d 2.0))
        p6      (polar p5 (znak (angle p5_temp p9) (/ pi 2)) dist1)
        p7      (polar p5 (angle p5_temp p9) d)
        p8      (polar p7 (znak (angle p5_temp p9) (/ pi 2)) dist2)
        p5_temp_dir (polar p5_temp (znak (angle p5_temp p9) (dtr 90)) 5)
        p5_dir  (polar p5 (znak (angle p5_temp p9) (/ pi 2)) 5)
        p7_dir  (polar p7 (znak (angle p5_temp p9) (/ pi 2)) 5)
	p14     (polar p5_temp (znak (angle p5_temp p9) (/ pi 2)) dist3)
  )
;;;=================================Radius=======================================

  (cond
    ((= de_type "de_radius")
     
     (setvar "osmode" 0)
     
     (if (= de_lay "1")
       (progn
         (command "_.layer" "_m" vp_lyr "_s" vp_lyr "")
	 (command "_.color" vp_clr)
       )
     )
     
     (if (= de_lay "1")
       (progn
         (command "_.layer" "_m" vp_lyr "_s" vp_lyr "")
	 (command "_.color" vp_clr)
       )
     )
  
     (command "_.line" p7 p5 "")

     (setq de_frm (list (entlast)))
     (setq de_frs (entlast))
     
     (command "_.arc" p5 "_e" p1 "_d" p5_dir)
     (command "_.arc" p7 "_e" p3 "_d" p7_dir)
     (command "_.line" p3 p1 "") 
  
     (if (= opt_1 "1")
       (progn
	 (if (= de_lay "1")
           (progn
             (command "_.layer" "_m" cl_lyr "_l" "center" cl_lyr "")
	     (command "_.color" cl_clr)
           )
         )
         (command "_.arc" p5_temp "_e" p1_temp "_d" p5_temp_dir)
       )
     )
    )	  
;;;===============================Mitered===================================

    ((= de_type "de_mitered")
     
     (command "_.undo" "_group")
     (setvar "osmode" 0)
  
     (if (= de_lay "1")
       (progn
         (command "_.layer" "_m" vp_lyr "_s" vp_lyr "")
	 (command "_.color" vp_clr)
       )
     )

     (command "_.line" p1 p3 "")

     (setq de_frm (list (entlast)))
     (setq de_frs (entlast))
     
     (command "_.line" p1 p2 "")
     (command "_.line" p3 p4 "")
     (command "_.line" p2 p4 "")
  
     (setq gross_ang (znak de_ang1 pi))
     (repeat (- pcs 2)
       (setq gross_ang (znak gross_ang (* 2.0 ang)))
       (setq p10 (polar p2 gross_ang (* 2.0 dist1)))
       (setq p11 (polar p4 gross_ang (* 2.0 dist2)))
       (command "_.line" p2  p10 "")
       (command "_.line" p4  p11 "")
       (command "_.line" p10 p11 "")
       (setq p2 p10)
       (setq p4 p11)
     )

     (if (= opt_1 "1")
       (progn
	 (if (= de_lay "1")
           (progn
             (command "_.layer" "_m" cl_lyr "_l" "center" cl_lyr "")
	     (command "_.color" cl_clr)
           )
         )
         (command "_.line" p1_temp p12 "")
	 (setq gross_ang (znak de_ang1 pi))
         (repeat (- pcs 2)
           (setq gross_ang (znak gross_ang (* 2.0 ang)))
           (setq p13 (polar p12 gross_ang (* 2.0 dist3)))
           (command "_.line" p12 p13 "")
           (setq p12 p13)
         )
	 (command "_.line" p14 p5_temp "")
       )
     )
     
     (if (= de_lay "1")
       (progn
         (command "_.layer" "_m" vp_lyr "_s" vp_lyr "")
	 (command "_.color" vp_clr)
       )
     )
    
     (command "_.line" p6 p5 "")
     (command "_.line" p8 p7 "")
     (command "_.line" p5 p7 "")     
    )
  )

  (while (setq de_frs (entnext de_frs))(setq de_frm (append de_frm (list de_frs))))

  (setq lstn (length de_frm))
  (setq no -1)
  (setq ss (ssadd))
  (repeat lstn
    (setq no (1+ no))
    (ssadd (nth no de_frm) ss)
  )

  (setvar "osmode" old_osnap)

  (command "_.rotate" ss "" de_ip pause)  
)
;;;===================================================================================

(defun tan (aa) (/ (sin aa) (cos aa)))
(defun dtr (bb) (/ (* pi bb) 180.0))

;;;=================================de_elb======================================

(defun de_elb ()

  (setq d   (atof de_dia)
        rd  (atof de_rd)
        pcs (atoi de_pcs)
        heg (atof de_heg)
  )

  (setq de_a1 (getpoint "\nFirst point :"))

  (cond
    ((= de_a1 nil)
     (princ "\nFunction cancelled!")
    )
    ((/= de_a1 nil)
     (de_els)
    )
  )
)
;;;=================================de_elf======================================
(defun de_els ()

  (check_eval)
  
  (setq de_a2 (getpoint de_a1 "\nCenter point :"))

  (cond
    ((= de_a2 nil)
     (princ "\nFunction cancelled!")
    )
    ((/= de_a2 nil)
     (grdraw de_a1 de_a2 -1 0)
     (de_elt)
    )
  )
)
  
;;;=================================de_elt======================================
(defun de_elt ()
  
  (setq de_a3 (getpoint de_a2 "\nEnd point :"))

  (cond
    ((= de_a3 nil)
     (redraw)
     (princ "\nFunction cancelled!")
    )
    ((/= de_a3 nil)
     (de_eld)
    )
  )
)
;;;=================================de_elt======================================
(defun de_eld ()
  
  (setq de_ang1 (angle de_a2 de_a1)
        de_ang2 (angle de_a2 de_a3)
        de_ang3 (- de_ang1 de_ang2)
  )

  (if (< de_ang3 0) (setq de_ang3 (+ (* pi 2) de_ang3)))
  
  (cond
    ((and (> de_ang3 0) (< de_ang3 pi))
     (setq de_ang (- pi de_ang3))
     (setq znak     +)
     (setq znak_obr -)
    )
    ((and (> de_ang3 pi) (< de_ang3 (* pi 2)))   
     (setq de_ang (- de_ang3 pi))
     (setq znak     -)
     (setq znak_obr +)
    )
  )

  (cond
    ((and (not (equal de_ang3 0 0.0001)) (not (equal de_ang3 pi 0.0001)))

     (if (= de_piece "0")
       (progn
	 (cond
	   ((<= de_ang (/ pi 6))
	    (setq pcs 2)
	   )
	   ((and (>= de_ang (/ pi 6)) (<= de_ang (/ pi 3)))
	    (setq pcs 3)
	   )
	   ((and (> de_ang (/ pi 3)) (< de_ang (/ pi 1.5)))
	    (setq pcs 4)
	   )
	   ((and (>= de_ang (/ pi 1.5)) (< de_ang (/ (* pi 5) 6)))
	    (setq pcs 5)
	   )
	   ((> de_ang (/ (* pi 5) 6))
	    (setq pcs 7)
	   )
	 )
       )
     )

     (setq ang   (/ de_ang (* 2 (- pcs 1)))
           dist1 (* (+ (* rd d) (/ d 2.0)) (tan ang))
           dist2 (* (- (* rd d) (/ d 2.0)) (tan ang))
	   dist3 (* (* rd d) (tan ang))
     )

     (setq p1_temp (polar de_a2 de_ang1 (* (* rd d) (tan (/ de_ang 2))))
           p1      (polar p1_temp (znak de_ang1 (/ pi 2)) (/ d 2.0))
           p2      (polar p1 (znak de_ang1 pi) dist1)
           p3      (polar p1 (znak_obr de_ang1 (/ pi 2)) d)
           p4      (polar p3 (znak de_ang1 pi) dist2)
	   p12     (polar p1_temp (znak de_ang1 pi) dist3)

           p9      (polar p1_temp (znak_obr de_ang1 (/ pi 2)) (* rd d))
           p5_temp (polar p9 (znak (angle p9 p1_temp) de_ang) (* rd d))
           p5      (polar p5_temp (angle p9 p5_temp) (/ d 2.0))
           p6      (polar p5 (znak (angle p5_temp p9) (/ pi 2)) dist1)
           p7      (polar p5 (angle p5_temp p9) d)
           p8      (polar p7 (znak (angle p5_temp p9) (/ pi 2)) dist2)
           p5_temp_dir (polar p5_temp (znak (angle p5_temp p9) (dtr 90)) 5)
           p5_dir  (polar p5 (znak (angle p5_temp p9) (/ pi 2)) 5)
           p7_dir  (polar p7 (znak (angle p5_temp p9) (/ pi 2)) 5)
	   p14     (polar p5_temp (znak (angle p5_temp p9) (/ pi 2)) dist3)
      )
;;;=================================Radius=======================================

      (cond
       ((= de_type "de_radius")
     
        (setvar "osmode" 0)
     
        (if (= de_lay "1")
          (progn
            (command "_.layer" "_m" vp_lyr "_s" vp_lyr "")
	    (command "_.color" vp_clr)
          )
        )
     
        (if (= de_lay "1")
          (progn
            (command "_.layer" "_m" vp_lyr "_s" vp_lyr "")
	    (command "_.color" vp_clr)
          )
        )
  
        (command "_.line" p7 p5 "")
        (command "_.arc" p5 "_e" p1 "_d" p5_dir)
        (command "_.arc" p7 "_e" p3 "_d" p7_dir)
        (command "_.line" p3 p1 "") 
  
        (if (= opt_1 "1")
          (progn
	    (if (= de_lay "1")
              (progn
                (command "_.layer" "_m" cl_lyr "_l" "center" cl_lyr "")
	        (command "_.color" cl_clr)
              )
            )
            (command "_.arc" p5_temp "_e" p1_temp "_d" p5_temp_dir)
          )
        )
       )	  
;;;===============================Mitered===================================

       ((= de_type "de_mitered")
     
        (command "_.undo" "_group")
        (setvar "osmode" 0)
  
        (if (= de_lay "1")
          (progn
            (command "_.layer" "_m" vp_lyr "_s" vp_lyr "")
	    (command "_.color" vp_clr)
          )
        )

        (command "_.line" p1 p3 "")
        (command "_.line" p1 p2 "")
        (command "_.line" p3 p4 "")
        (command "_.line" p2 p4 "")
  
        (setq gross_ang (znak de_ang1 pi))
        (repeat (- pcs 2)
          (setq gross_ang (znak gross_ang (* 2.0 ang)))
          (setq p10 (polar p2 gross_ang (* 2.0 dist1)))
          (setq p11 (polar p4 gross_ang (* 2.0 dist2)))
          (command "_.line" p2  p10 "")
          (command "_.line" p4  p11 "")
          (command "_.line" p10 p11 "")
          (setq p2 p10)
          (setq p4 p11)
        )

        (if (= opt_1 "1")
          (progn
	    (if (= de_lay "1")
              (progn
                (command "_.layer" "_m" cl_lyr "_l" "center" cl_lyr "")
	        (command "_.color" cl_clr)
              )
            )
            (command "_.line" p1_temp p12 "")
	    (setq gross_ang (znak de_ang1 pi))
            (repeat (- pcs 2)
              (setq gross_ang (znak gross_ang (* 2.0 ang)))
              (setq p13 (polar p12 gross_ang (* 2.0 dist3)))
              (command "_.line" p12 p13 "")
              (setq p12 p13)
            )
	    (command "_.line" p14 p5_temp "")
          )
        )
     
        (if (= de_lay "1")
          (progn
            (command "_.layer" "_m" vp_lyr "_s" vp_lyr "")
	    (command "_.color" vp_clr)
          )
        )
    
        (command "_.line" p6 p5 "")
        (command "_.line" p8 p7 "")
        (command "_.line" p5 p7 "")
       )
     )
     (redraw)
    )
    ((or (equal de_ang3 0 0.0001) (equal de_ang3 pi 0.0001))
     (redraw)
     (princ "\nAngle must be more than 0 and less than 180 degrees")
    )
  )
)
;;;=================================de_anl======================================

(defun de_anl ()

  (check_eval)

  (setq d   (atof de_dia)
        heg (atof de_heg)
  )

  (setq de_ip  (getpoint "\nInsertion point : "))

  (cond
    ((= de_ip nil)
     (princ "\nFunction cancelled!")
    )
    ((/= de_ip nil)
     (setq de_br1 (ssget de_ip))

     (cond
       ((and (/= de_br1 nil) (= dp_auto "1") (setq x_list (assoc -3 (entget (ssname de_br1 0) (list "hvac_duct")))))
        (get_base)
        (de_pad)
       )
       ((and (/= de_br1 nil) (= dp_auto "1") (setq x_list (assoc -3 (entget (ssname de_br1 0) (list "hvac_end")))))
	(get_end_base)
	(de_ped)
       )
       (T
	(de_pdl)
       )
     )
    )
  )
)
;;;=================================de_pad======================================

(defun de_pad ()

  (setq de_ip (polar de_ip dp_mda (/ dp_mds 2.0))
        p1 (polar de_ip dp_mda (/ d 2.0))
	p2 (polar de_ip (+ dp_mda pi) (/ d 2.0))
	p3 (polar p1 (+ dp_mda (/ pi 2)) (/ heg 2.0))
	p4 (polar p2 (+ dp_mda (/ pi 2)) (/ heg 2.0))
	p5 (polar p1 (- dp_mda (/ pi 2)) (/ heg 2.0))
	p6 (polar p2 (- dp_mda (/ pi 2)) (/ heg 2.0))
  )

  (cond
    ((= de_type "de_radius")
      
     (setvar "osmode" 0)

     (if (= opt_1 "1")
       (progn
         (setq p7 (polar de_ip dp_mda (* 1.5 (/ d 2.0)))
               p8 (polar de_ip (+ dp_mda pi) (* 1.5 (/ d 2.0)))
               p9 (polar de_ip (- dp_mda (/ pi 2)) (* 1.5 (/ d 2.0)))
	       p10 (polar de_ip (+ dp_mda (/ pi 2)) (* 1.5 (/ d 2.0)))
         )
       )
     )

     (if (= opt_1 "1")
       (progn
	 (if (= de_lay "1")
	   (progn
              (command "_.layer" "m" cl_lyr "l" "center" cl_lyr "")
	      (command "_.color" cl_clr)
           )
	 ) 
         (command "_.line" p7 p8 "")
         (command "_.line" p9 p10 "")
       )
     )
       
     (if (= de_lay "1")
       (progn
	 (command "_.layer" "m" vp_lyr "s" vp_lyr "")
	 (command "_.color" vp_clr)
       )
     )

     (command "_.circle" de_ip p2)
    )
    ((= de_type "de_mitered")

     (setvar "osmode" 0)

     (if (= opt_1 "1")
       (progn
	 (setq de_od (min d heg))  
         (setq p7  (polar de_ip dp_mda (+ (/ heg 2) (/ de_od 4)))
               p8  (polar de_ip (+ dp_mda pi) (+ (/ heg 2) (/ de_od 4)))
               p9  (polar de_ip (- dp_mda (/ pi 2)) (+ (/ d 2) (/ de_od 4)))
	       p10 (polar de_ip (+ dp_mda (/ pi 2)) (+ (/ d 2) (/ de_od 4)))
         )
       )
     )

     (if (= opt_1 "1")
       (progn
	 (if (= de_lay "1")
	   (progn
              (command "_.layer" "m" cl_lyr "l" "center" cl_lyr "")
	      (command "_.color" cl_clr)
           )
	 ) 
         (command "_.line" p7 p8 "")
         (command "_.line" p9 p10 "")
       )
     )

     (if (= de_lay "1")
       (progn
	 (command "_.layer" "m" vp_lyr "s" vp_lyr "")
	 (command "_.color" vp_clr)
       )
     )

     (command "_.pline" p3 p5 p6 p4 p3 "")
    )
  )
)
;;;=================================de_ped======================================

(defun de_ped ()

  (setq de_ip dp_e1
        p1 (polar de_ip (- dp_mda (/ pi 2)) (/ dp_mds 2.0))
	p2 (polar de_ip (+ dp_mda (/ pi 2)) (/ dp_mds 2.0))	
  )

  (setq de_del (entdel (cdr (assoc -1 (entget (ssname de_br1 0))))))

  (cond
    ((= d_type "RND_DUCT")
      
     (setvar "osmode" 0)

     (if (= opt_1 "1")
       (progn
         (setq p7 (polar de_ip dp_mda (* 1.5 (/ dp_mds 2.0)))
               p8 (polar de_ip (+ dp_mda pi) (* 1.5 (/ dp_mds 2.0)))
               p9 (polar de_ip (- dp_mda (/ pi 2)) (* 1.5 (/ dp_mds 2.0)))
	       p10 (polar de_ip (+ dp_mda (/ pi 2)) (* 1.5 (/ dp_mds 2.0)))
         )
       )
     )

     (if (= opt_1 "1")
       (progn
	 (if (= de_lay "1")
	   (progn
              (command "_.layer" "m" cl_lyr "l" "center" cl_lyr "")
	      (command "_.color" cl_clr)
           )
	 ) 
         (command "_.line" p7 p8 "")
         (command "_.line" p9 p10 "")
       )
     )
       
     (if (= de_lay "1")
       (progn
	 (command "_.layer" "m" vp_lyr "s" vp_lyr "")
	 (command "_.color" vp_clr)
       )
     )

     (command "_.circle" de_ip p2)
    )
    ((= d_type "RECT_DUCT")

     (setvar "osmode" 0)

     (setq p3 (polar p1 dp_mda (/ dp_mdh 2.0))
	   p4 (polar p2 dp_mda (/ dp_mdh 2.0))
	   p5 (polar p1 (+ dp_mda pi) (/ dp_mdh 2.0))
	   p6 (polar p2 (+ dp_mda pi) (/ dp_mdh 2.0))
     )

     (if (= opt_1 "1")
       (progn
	 (setq de_od (min dp_mds dp_mdh))  
         (setq p7  (polar de_ip dp_mda (+ (/ dp_mdh 2) (/ de_od 4)))
               p8  (polar de_ip (+ dp_mda pi) (+ (/ dp_mdh 2) (/ de_od 4)))
               p9  (polar de_ip (- dp_mda (/ pi 2)) (+ (/ dp_mds 2) (/ de_od 4)))
	       p10 (polar de_ip (+ dp_mda (/ pi 2)) (+ (/ dp_mds 2) (/ de_od 4)))
         )
       )
     )

     (if (= opt_1 "1")
       (progn
	 (if (= de_lay "1")
	   (progn
              (command "_.layer" "m" cl_lyr "l" "center" cl_lyr "")
	      (command "_.color" cl_clr)
           )
	 ) 
         (command "_.line" p7 p8 "")
         (command "_.line" p9 p10 "")
       )
     )

     (if (= de_lay "1")
       (progn
	 (command "_.layer" "m" vp_lyr "s" vp_lyr "")
	 (command "_.color" vp_clr)
       )
     )

     (command "_.pline" p3 p5 p6 p4 p3 "")
    )
  )
)
;;;=================================de_pdl======================================

(defun de_pdl ()

  (setq p1 (polar de_ip (/ pi 2) (/ d 2.0))
	p2 (polar de_ip (* pi 1.5) (/ d 2.0))
	p3 (polar p1 0 (/ heg 2.0))
	p4 (polar p2 0 (/ heg 2.0))
	p5 (polar p1 pi (/ heg 2.0))
	p6 (polar p2 pi (/ heg 2.0))
  )

  (cond
    ((= de_type "de_radius")
      
     (setvar "osmode" 0)

     (if (= opt_1 "1")
       (progn
         (setq p7  (polar de_ip (/ pi 2) (* 1.5 (/ d 2.0)))
               p8  (polar de_ip (* pi 1.5) (* 1.5 (/ d 2.0)))
               p9  (polar de_ip pi (* 1.5 (/ d 2.0)))
	       p10 (polar de_ip 0 (* 1.5 (/ d 2.0)))
         )
       )
     )
       
     (if (= de_lay "1")
       (progn
	 (command "_.layer" "m" vp_lyr "s" vp_lyr "")
	 (command "_.color" vp_clr)
       )
     )

     (command "_.circle" de_ip p2)

     (setq de_frm (list (entlast)))
     (setq de_frs (entlast))

     (if (= opt_1 "1")
       (progn
	 (if (= de_lay "1")
	   (progn
              (command "_.layer" "m" cl_lyr "l" "center" cl_lyr "")
	      (command "_.color" cl_clr)
           )
	 ) 
         (command "_.line" p7 p8 "")
         (command "_.line" p9 p10 "")
       )
     )
    )
    ((= de_type "de_mitered")

     (setvar "osmode" 0)

     (if (= opt_1 "1")
       (progn
	 (setq de_od (min d heg))  
         (setq p7  (polar de_ip 0 (+ (/ heg 2) (/ de_od 4)))
               p8  (polar de_ip pi (+ (/ heg 2) (/ de_od 4)))
               p9  (polar de_ip (/ pi 2) (+ (/ d 2) (/ de_od 4)))
	       p10 (polar de_ip (* pi 1.5) (+ (/ d 2) (/ de_od 4)))
         )
       )
     )

     (if (= de_lay "1")
       (progn
	 (command "_.layer" "m" vp_lyr "s" vp_lyr "")
	 (command "_.color" vp_clr)
       )
     )

     (command "_.pline" p3 p5 p6 p4 p3 "")

     (setq de_frm (list (entlast)))
     (setq de_frs (entlast))

     (if (= opt_1 "1")
       (progn
	 (if (= de_lay "1")
	   (progn
              (command "_.layer" "m" cl_lyr "l" "center" cl_lyr "")
	      (command "_.color" cl_clr)
           )
	 ) 
         (command "_.line" p7 p8 "")
         (command "_.line" p9 p10 "")
       )
     )
    )
  )

  (while (setq de_frs (entnext de_frs))(setq de_frm (append de_frm (list de_frs))))

  (setq lstn (length de_frm))
  (setq no -1)
  (setq ss (ssadd))
  (repeat lstn
    (setq no (1+ no))
    (ssadd (nth no de_frm) ss)
  )

  (setvar "osmode" old_osnap)

  (command "_.rotate" ss "" de_ip pause)
)
;;;=================================de_gds======================================

(defun de_gds ()

  (setq de_d1 (getpoint "\nPick a Pipe or first point :"))
  (if (/= de_d1 nil)
    (setq ss_a1 (ssget de_d1))
  )
  
  (cond
    ((and (/= de_d1 nil) (/= ss_a1 nil) (setq x_list (assoc -3 (entget (ssname ss_a1 0) (list "hvac_duct")))))
     (get_base)
     (cond
       ((= d_type "RND_DUCT")
        (setq de_dia (rtos dp_mds))
        (princ (strcat "\nRound Pipe <" de_dia ">\n"))
       )
       ((= d_type "RECT_DUCT")
	(setq de_dia (rtos dp_mds))
	(setq de_heg (rtos dp_mdh))
	(princ (strcat "\nRectangular Pipe <" de_dia "x" de_heg ">\n"))
       )
     )
    )
    ((= de_d1 nil)
     (princ "Old paramethers\n")
    )
    (T
     (setq de_d2 (getpoint de_d1 "\nSpecify second point :"))
     (cond
      ((= de_d2 nil)
       (setq de_dia de_dia_old)
       (princ "Old paramethers\n")
      )
      ((/= de_d2 nil)
       (setq de_dia (rtos (distance de_d1 de_d2)))

       (cond
	 ((and (= t_type "t_txt1") (/= (atof de_dia) 0.0))
	  (princ (strcat "\nRound Pipe <" de_dia ">\n"))
	 )
	 ((and (= t_type "t_txt2") (/= (atof de_dia) 0.0))
	  (princ (strcat "\nRectangular Pipe <" de_dia "x" de_heg ">\n"))
	 )
	 ((= (atof de_dia) 0.0)
	  (setq de_dia de_dia_old)
	  (princ "\nImproper value! Distance must be more than 0\n")
	 )
       )
      )
     )
    )
  )
)
;;;=================================de_ans======================================

(defun de_ans ()

  (setq de_a1 (getpoint "\nFirst point :"))

  (cond
    ((= de_a1 nil)
     (princ "Old paramethers\n")
    )
    ((/= de_a1 nil)
     (de_anv)
    )
  )
)
;;;=================================de_anv======================================

(defun de_anv ()

  (setq de_a2 (getpoint de_a1 "\nCenter point :"))

  (cond
    ((= de_a2 nil)
     (redraw)
     (princ "Old paramethers\n")
    )
    ((/= de_a2 nil)
     (grdraw de_a1 de_a2 -1 0)
     (de_ant)
    )
  )
)
;;;=================================de_ant======================================
(defun de_ant ()
  
  (setq de_a3 (getpoint de_a2 "\nEnd point :"))

  (cond
    ((= de_a3 nil)
     (redraw)
     (princ "Old paramethers\n")
    )
    ((/= de_a3 nil)
     (de_and)
    )
  )
)
;;;=================================de_ant======================================
(defun de_and ()

  (setq de_ang1 (angle de_a2 de_a1)
        de_ang2 (angle de_a2 de_a3)
        de_ang3 (- de_ang1 de_ang2)
  )

  (if (< de_ang3 0) (setq de_ang3 (+ (* pi 2) de_ang3)))
    (setq de_ang3 (* de_ang3 (/ 180.0 pi))
  )
  
  (cond
    ((and (> de_ang3 0) (< de_ang3 180))
       (setq de_ang_abs (- 180.0 de_ang3)
       )
    )
    ((and (> de_ang3 180) (< de_ang3 360))   
       (setq de_ang_abs (- de_ang3 180.0)
       )
    )
  )
  (cond
    ((and (/= de_ang3 0) (/= de_ang3 180))
     (redraw)
     (setq de_angle (rtos de_ang_abs 2 1))
    )
    ((or (= de_ang3 0) (= de_ang3 180))
     (redraw)
     (princ "Angle must be more than 0 and less than 180 degrees\n")
    )
  )
)
;================================get_base=====================================

(defun get_base ()

  (setq x_list (cdadr x_list))
  (setq d_type (cdr (assoc 1000 x_list)))

  (cond
    ((= d_type "RND_DUCT")
     (setq dp_mda (cdr (nth 0 x_list)))
     (setq dp_mds (cdr (nth 1 x_list)))
    )
    ((= d_type "RECT_DUCT")
     (setq dp_mda (cdr (nth 0 x_list)))
     (setq dp_mdh (cdr (nth 1 x_list)))
     (setq dp_mds (cdr (nth 2 x_list)))
    )
  )
)
;================================get_end_base=====================================

(defun get_end_base ()

  (setq x_list (cdadr x_list))
  (setq d_type (cdr (assoc 1000 x_list)))

  (cond
    ((= d_type "RND_DUCT")
     (setq dp_mda (cdr (nth 0 x_list)))
     (setq dp_mds (cdr (nth 1 x_list)))
     (setq dp_e1  (cdr (assoc 1011 x_list)))
    )
    ((= d_type "RECT_DUCT")
     (setq dp_mda (cdr (nth 0 x_list)))
     (setq dp_mdh (cdr (nth 1 x_list)))
     (setq dp_mds (cdr (nth 2 x_list)))
     (setq dp_e1  (cdr (assoc 1011 x_list)))
    )
  )
)
;;;================================de_img_fill=========================================

(defun de_img_fill ()
    (cond
      ((and (= de_pt "supply")(or (= de_shape "elbow")(= de_shape "front"))(= de_type "de_mitered")(= de_sign "de_left")(= opt_1 "1"))
       (setq slide "de_p1")
      )
      ((and (= de_pt "supply")(or (= de_shape "elbow")(= de_shape "front"))(= de_type "de_mitered")(= de_sign "de_left")(= opt_1 "0"))
       (setq slide "de_p2")
      )
      ((and (= de_pt "supply")(or (= de_shape "elbow")(= de_shape "front"))(= de_type "de_radius")(= de_sign "de_left")(= opt_1 "1"))
       (setq slide "de_p3")
      )
      ((and (= de_pt "supply")(or (= de_shape "elbow")(= de_shape "front"))(= de_type "de_radius")(= de_sign "de_left")(= opt_1 "0"))
       (setq slide "de_p4")
      )
      ((and (= de_pt "supply")(or (= de_shape "elbow")(= de_shape "front"))(= de_type "de_mitered")(= de_sign "de_rigth")(= opt_1 "1"))
       (setq slide "de_p5")
      )
      ((and (= de_pt "supply")(or (= de_shape "elbow")(= de_shape "front"))(= de_type "de_mitered")(= de_sign "de_rigth")(= opt_1 "0"))
       (setq slide "de_p6")
      )
      ((and (= de_pt "supply")(or (= de_shape "elbow")(= de_shape "front"))(= de_type "de_radius")(= de_sign "de_rigth")(= opt_1 "1"))
       (setq slide "de_p7")
      )
      ((and (= de_pt "supply")(or (= de_shape "elbow")(= de_shape "front"))(= de_type "de_radius")(= de_sign "de_rigth")(= opt_1 "0"))
       (setq slide "de_p8")
      )
      ((and (= de_pt "supply")(= de_shape "plan")(= de_type "de_mitered")(= opt_1 "1"))
       (setq slide "de_p9")
      )
      ((and (= de_pt "supply")(= de_shape "plan")(= de_type "de_mitered")(= opt_1 "0"))
       (setq slide "de_p10")
      )
      ((and (= de_pt "supply")(= de_shape "plan")(= de_type "de_radius")(= opt_1 "1"))
       (setq slide "de_p11")
      )
      ((and (= de_pt "supply")(= de_shape "plan")(= de_type "de_radius")(= opt_1 "0"))
       (setq slide "de_p12")
      )
      ((and (= de_pt "supply")(= de_shape "bottom")(= de_type "de_mitered")(= opt_1 "1"))
       (setq slide "de_p13")
      )
      ((and (= de_pt "supply")(= de_shape "bottom")(= de_type "de_mitered")(= opt_1 "0"))
       (setq slide "de_p14")
      )
      ((and (= de_pt "supply")(= de_shape "bottom")(= de_type "de_radius")(= opt_1 "1"))
       (setq slide "de_p39")
      )
      ((and (= de_pt "supply")(= de_shape "bottom")(= de_type "de_radius")(= opt_1 "0"))
       (setq slide "de_p40")
      )
      ((and (= de_pt "supply")(= de_shape "pipe")(= de_type "de_mitered")(= opt_1 "1"))
       (setq slide "de_p15")
      )
      ((and (= de_pt "supply")(= de_shape "pipe")(= de_type "de_mitered")(= opt_1 "0"))
       (setq slide "de_p16")
      )
      ((and (= de_pt "supply")(= de_shape "pipe")(= de_type "de_radius")(= opt_1 "1"))
       (setq slide "de_p17")
      )
      ((and (= de_pt "supply")(= de_shape "pipe")(= de_type "de_radius")(= opt_1 "0"))
       (setq slide "de_p18")
      )
      ((and (= de_pt "exhaust")(or (= de_shape "elbow")(= de_shape "front"))(= de_type "de_mitered")(= de_sign "de_left")(= opt_1 "1"))
       (setq slide "de_p19")
      )
      ((and (= de_pt "exhaust")(or (= de_shape "elbow")(= de_shape "front"))(= de_type "de_mitered")(= de_sign "de_left")(= opt_1 "0"))
       (setq slide "de_p20")
      )
      ((and (= de_pt "exhaust")(or (= de_shape "elbow")(= de_shape "front"))(= de_type "de_radius")(= de_sign "de_left")(= opt_1 "1"))
       (setq slide "de_p21")
      )
      ((and (= de_pt "exhaust")(or (= de_shape "elbow")(= de_shape "front"))(= de_type "de_radius")(= de_sign "de_left")(= opt_1 "0"))
       (setq slide "de_p22")
      )
      ((and (= de_pt "exhaust")(or (= de_shape "elbow")(= de_shape "front"))(= de_type "de_mitered")(= de_sign "de_rigth")(= opt_1 "1"))
       (setq slide "de_p23")
      )
      ((and (= de_pt "exhaust")(or (= de_shape "elbow")(= de_shape "front"))(= de_type "de_mitered")(= de_sign "de_rigth")(= opt_1 "0"))
       (setq slide "de_p24")
      )
      ((and (= de_pt "exhaust")(or (= de_shape "elbow")(= de_shape "front"))(= de_type "de_radius")(= de_sign "de_rigth")(= opt_1 "1"))
       (setq slide "de_p25")
      )
      ((and (= de_pt "exhaust")(or (= de_shape "elbow")(= de_shape "front"))(= de_type "de_radius")(= de_sign "de_rigth")(= opt_1 "0"))
       (setq slide "de_p26")
      )
      ((and (= de_pt "exhaust")(= de_shape "plan")(= de_type "de_mitered")(= opt_1 "1"))
       (setq slide "de_p27")
      )
      ((and (= de_pt "exhaust")(= de_shape "plan")(= de_type "de_mitered")(= opt_1 "0"))
       (setq slide "de_p28")
      )
      ((and (= de_pt "exhaust")(= de_shape "plan")(= de_type "de_radius")(= opt_1 "1"))
       (setq slide "de_p29")
      )
      ((and (= de_pt "exhaust")(= de_shape "plan")(= de_type "de_radius")(= opt_1 "0"))
       (setq slide "de_p30")
      )
      ((and (= de_pt "exhaust")(= de_shape "bottom")(= de_type "de_mitered")(= opt_1 "1"))
       (setq slide "de_p31")
      )
      ((and (= de_pt "exhaust")(= de_shape "bottom")(= de_type "de_mitered")(= opt_1 "0"))
       (setq slide "de_p32")
      )
      ((and (= de_pt "exhaust")(= de_shape "bottom")(= de_type "de_radius")(= opt_1 "1"))
       (setq slide "de_p33")
      )
      ((and (= de_pt "exhaust")(= de_shape "bottom")(= de_type "de_radius")(= opt_1 "0"))
       (setq slide "de_p34")
      )
      ((and (= de_pt "exhaust")(= de_shape "pipe")(= de_type "de_mitered")(= opt_1 "1"))
       (setq slide "de_p35")
      )
      ((and (= de_pt "exhaust")(= de_shape "pipe")(= de_type "de_mitered")(= opt_1 "0"))
       (setq slide "de_p36")
      )
      ((and (= de_pt "exhaust")(= de_shape "pipe")(= de_type "de_radius")(= opt_1 "1"))
       (setq slide "de_p37")
      )
      ((and (= de_pt "exhaust")(= de_shape "pipe")(= de_type "de_radius")(= opt_1 "0"))
       (setq slide "de_p38")
      )
    )
  (setq de_slide (strcat "de_view(" slide ")" ))
  (setq xdim (dimx_tile "de_image"))
  (setq ydim (dimy_tile "de_image"))
  (start_image "de_image")
  (fill_image 0 0 xdim ydim 0)
  (slide_image 0 0 xdim ydim de_slide)
  (end_image)
)
;================================eval_de=====================================

(defun eval_de ()
  (cond
    ((= de_pt "supply")
       (progn
         (setq vp_lyr sup_lyr)
         (setq cl_lyr scl_lyr)
         (setq tl_lyr stl_lyr)
	 (setq ac_lyr sac_lyr)
         (setq vp_clr sup_clr)
         (setq cl_clr scl_clr)
         (setq tl_clr stl_clr)
	 (setq ac_clr sac_clr)
       )
    )
    ((= de_pt "exhaust")
       (progn
         (setq vp_lyr exh_lyr)
         (setq cl_lyr ecl_lyr)
         (setq tl_lyr etl_lyr)
	 (setq ac_lyr eac_lyr)
         (setq vp_clr exh_clr)
         (setq cl_clr ecl_clr)
         (setq tl_clr etl_clr)
	 (setq ac_clr eac_clr)
       )
    )
  )
)
;==================================check_eval=====================================

(defun check_eval ()

  (if (tblsearch "layer" vp_lyr)
    (if (/= (cdr (assoc 70 (tblsearch "layer" vp_lyr))) 0)
      (progn
        (setq vp_st  (entget (tblobjname "layer" vp_lyr)))
        (setq vp_rh  (assoc 70 vp_st))
        (setq vp_nch (cons 70 0))
        (setq vp_nst (subst vp_nch vp_rh vp_st))
        (entmod vp_nst)
      )
    )
  )
  
  (if (tblsearch "layer" vp_lyr)
    (if (/= (cdr (assoc 62 (tblsearch "layer" vp_lyr))) 7)
      (progn
        (setq vp_ft  (entget (tblobjname "layer" vp_lyr)))
        (setq vp_rf  (assoc 62 vp_ft))
        (setq vp_ncf (cons 62 7))
        (setq vp_fst (subst vp_ncf vp_rf vp_ft))
        (entmod vp_fst)
      )
    )
  )

  (if (tblsearch "layer" cl_lyr)
    (if (/= (cdr (assoc 70 (tblsearch "layer" cl_lyr))) 0)
      (progn
        (setq cl_st  (entget (tblobjname "layer" cl_lyr)))
        (setq cl_rh  (assoc 70 cl_st))
        (setq cl_nch (cons 70 0))
        (setq cl_nst (subst cl_nch cl_rh cl_st))
        (entmod cl_nst)
      )
    )
  )

  (if (tblsearch "layer" cl_lyr)
    (if (/= (cdr (assoc 62 (tblsearch "layer" cl_lyr))) 7)
      (progn
        (setq cl_ft  (entget (tblobjname "layer" cl_lyr)))
        (setq cl_rf  (assoc 62 cl_ft))
        (setq cl_ncf (cons 62 7))
        (setq cl_fst (subst cl_ncf cl_rf cl_ft))
        (entmod cl_fst)
      )
    )
  )

  (if (tblsearch "layer" tl_lyr)
    (if (/= (cdr (assoc 70 (tblsearch "layer" tl_lyr))) 0)
      (progn
        (setq tl_st  (entget (tblobjname "layer" tl_lyr)))
        (setq tl_rh  (assoc 70 tl_st))
        (setq tl_nch (cons 70 0))
        (setq tl_nst (subst tl_nch tl_rh tl_st))
        (entmod tl_nst)
      )
    )
  )

  (if (tblsearch "layer" tl_lyr)
    (if (/= (cdr (assoc 62 (tblsearch "layer" tl_lyr))) 7)
      (progn
        (setq tl_ft  (entget (tblobjname "layer" tl_lyr)))
        (setq tl_rf  (assoc 62 tl_ft))
        (setq tl_ncf (cons 62 7))
        (setq tl_fst (subst tl_ncf tl_rf tl_ft))
        (entmod tl_fst)
      )
    )
  )

  (if (tblsearch "layer" ac_lyr)
    (if (/= (cdr (assoc 70 (tblsearch "layer" ac_lyr))) 0)
      (progn
        (setq ac_st  (entget (tblobjname "layer" ac_lyr)))
        (setq ac_rh  (assoc 70 ac_st))
        (setq ac_nch (cons 70 0))
        (setq ac_nst (subst ac_nch ac_rh ac_st))
        (entmod ac_nst)
      )
    )
  )

  (if (tblsearch "layer" ac_lyr)
    (if (/= (cdr (assoc 62 (tblsearch "layer" ac_lyr))) 7)
      (progn
        (setq ac_ft  (entget (tblobjname "layer" ac_lyr)))
        (setq ac_rf  (assoc 62 ac_ft))
        (setq ac_ncf (cons 62 7))
        (setq ac_fst (subst ac_ncf ac_rf ac_ft))
        (entmod ac_fst)
      )
    )
  )
)
;======================================================

(defun sup_set ()
	(setq sup_clr (acad_colordlg sup_clr))
        (if (= sup_clr nil)
	  (setq sup_clr sup_clr_old)
	)
     (sup_img)
     (set_tile "sup_clr" (itoa sup_clr))
)
;======================================================

(defun exh_set ()
	(setq exh_clr (acad_colordlg exh_clr))
        (if (= exh_clr nil)
	  (setq exh_clr exh_clr_old)
	)
     (exh_img)
     (set_tile "exh_clr" (itoa exh_clr))
)
;======================================================

(defun scl_set ()
	(setq scl_clr (acad_colordlg scl_clr))
        (if (= scl_clr nil)
	  (setq scl_clr scl_clr_old)
	)
     (scl_img)
     (set_tile "scl_clr" (itoa scl_clr))
)
;======================================================

(defun ecl_set ()
	(setq ecl_clr (acad_colordlg ecl_clr))
        (if (= ecl_clr nil)
	  (setq ecl_clr ecl_clr_old)
	)
     (ecl_img)
     (set_tile "ecl_clr" (itoa ecl_clr))
)
;======================================================

(defun stl_set ()
	(setq stl_clr (acad_colordlg stl_clr))
        (if (= stl_clr nil)
	  (setq stl_clr stl_clr_old)
	)
     (stl_img)
     (set_tile "stl_clr" (itoa stl_clr))
)
;======================================================

(defun etl_set ()
	(setq etl_clr (acad_colordlg etl_clr))
        (if (= etl_clr nil)
	  (setq etl_clr etl_clr_old)
	)
     (etl_img)
     (set_tile "etl_clr" (itoa etl_clr))
)
;======================================================

(defun sac_set ()
	(setq sac_clr (acad_colordlg sac_clr))
        (if (= sac_clr nil)
	  (setq sac_clr sac_clr_old)
	)
     (sac_img)
     (set_tile "sac_clr" (itoa sac_clr))
)
;======================================================

(defun eac_set ()
	(setq eac_clr (acad_colordlg eac_clr))
        (if (= eac_clr nil)
	  (setq eac_clr eac_clr_old)
	)
     (eac_img)
     (set_tile "eac_clr" (itoa eac_clr))
)
;======================================================

(defun sup_img ()
 (start_image "sup_box")
   (fill_image
        0
        0
        (dimx_tile "sup_box")
        (dimy_tile "sup_box")
        sup_clr
   )
 (end_image)
)
;======================================================

(defun sup_img ()
 (start_image "sup_box")
   (fill_image
        0
        0
        (dimx_tile "sup_box")
        (dimy_tile "sup_box")
        sup_clr
   )
 (end_image)
)
;======================================================

(defun exh_img ()
 (start_image "exh_box")
   (fill_image
        0
        0
        (dimx_tile "exh_box")
        (dimy_tile "exh_box")
        exh_clr
   )
 (end_image)
)
;======================================================

(defun scl_img ()
 (start_image "scl_box")
   (fill_image
        0
        0
        (dimx_tile "scl_box")
        (dimy_tile "scl_box")
        scl_clr
   )
 (end_image)
)
;======================================================

(defun ecl_img ()
 (start_image "ecl_box")
   (fill_image
        0
        0
        (dimx_tile "ecl_box")
        (dimy_tile "ecl_box")
        ecl_clr
   )
 (end_image)
)
;======================================================

(defun stl_img ()
 (start_image "stl_box")
   (fill_image
        0
        0
        (dimx_tile "stl_box")
        (dimy_tile "stl_box")
        stl_clr
   )
 (end_image)
)
;======================================================

(defun etl_img ()
 (start_image "etl_box")
   (fill_image
        0
        0
        (dimx_tile "etl_box")
        (dimy_tile "etl_box")
        etl_clr
   )
 (end_image)
)
;======================================================

(defun sac_img ()
 (start_image "sac_box")
   (fill_image
        0
        0
        (dimx_tile "sac_box")
        (dimy_tile "sac_box")
        sac_clr
   )
 (end_image)
)
;======================================================

(defun eac_img ()
 (start_image "eac_box")
   (fill_image
        0
        0
        (dimx_tile "eac_box")
        (dimy_tile "eac_box")
        eac_clr
   )
 (end_image)
)
;;;=================================save_cfg======================================

(defun save_dp ()

  (setq de_cfg (strcat (vl-filename-directory (findfile "delbow.lsp")) "\\" "delbow.cfg"))
  (princ (strcat "\nSaving current layer settings as default..." "delbow.cfg\n"))
  (setq de_fh (open de_cfg "w"))
  (write-line "*** Configuration file for HVAC Duct program ***" de_fh)
  (write-line "Supply Air layer:" de_fh)
  (write-line sup_lyr de_fh)
  (write-line "Supply Air layer color:" de_fh)
  (write-line (itoa sup_clr) de_fh)
  (write-line "Supply Air Center Line layer:" de_fh)
  (write-line scl_lyr de_fh)
  (write-line "Supply Air Center Line layer color:" de_fh)
  (write-line (itoa scl_clr) de_fh)
  (write-line "Supply Air Text Line layer:" de_fh)
  (write-line stl_lyr de_fh)
  (write-line "Supply Air Text Line layer color:" de_fh)
  (write-line (itoa stl_clr) de_fh)
  (write-line "Supply Air Accessories layer:" de_fh)
  (write-line sac_lyr de_fh)
  (write-line "Supply Air Accessories layer color:" de_fh)
  (write-line (itoa sac_clr) de_fh)
  (write-line "Exhaust Air layer:" de_fh)
  (write-line exh_lyr de_fh)
  (write-line "Exhaust Air layer color:" de_fh)
  (write-line (itoa exh_clr) de_fh)
  (write-line "Exhaust Air Center Line layer:" de_fh)
  (write-line ecl_lyr de_fh)
  (write-line "Exhaust Air Center Line layer color:" de_fh)
  (write-line (itoa ecl_clr) de_fh)
  (write-line "Exhaust Air Text Line layer:" de_fh)
  (write-line etl_lyr de_fh)
  (write-line "Exhaust Air Text Line layer color:" de_fh)
  (write-line (itoa etl_clr) de_fh)
  (write-line "Exhaust Air Accessories layer:" de_fh)
  (write-line eac_lyr de_fh)
  (write-line "Exhaust Air Accessories layer color:" de_fh)
  (write-line (itoa eac_clr) de_fh)
  (write-line "End of File..." de_fh) 
  (close de_fh)

  (setq rd_cfg (open de_cfg "r"))
  (read-line rd_cfg) 
  (read-line rd_cfg) 
  (setq sup_lyr (read-line rd_cfg))
  (read-line rd_cfg) 
  (setq sup_clr (atoi (read-line rd_cfg)))
  (read-line rd_cfg) 
  (setq scl_lyr (read-line rd_cfg))
  (read-line rd_cfg) 
  (setq scl_clr (atoi (read-line rd_cfg)))
  (read-line rd_cfg) 
  (setq stl_lyr (read-line rd_cfg))
  (read-line rd_cfg) 
  (setq stl_clr (atoi (read-line rd_cfg)))
  (read-line rd_cfg) 
  (setq sac_lyr (read-line rd_cfg))
  (read-line rd_cfg) 
  (setq sac_clr (atoi (read-line rd_cfg)))
  (read-line rd_cfg) 
  (setq exh_lyr (read-line rd_cfg))
  (read-line rd_cfg) 
  (setq exh_clr (atoi (read-line rd_cfg)))
  (read-line rd_cfg) 
  (setq ecl_lyr (read-line rd_cfg))
  (read-line rd_cfg) 
  (setq ecl_clr (atoi (read-line rd_cfg)))
  (read-line rd_cfg) 
  (setq etl_lyr (read-line rd_cfg))
  (read-line rd_cfg) 
  (setq etl_clr (atoi (read-line rd_cfg)))
  (read-line rd_cfg) 
  (setq eac_lyr (read-line rd_cfg))
  (read-line rd_cfg) 
  (setq eac_clr (atoi (read-line rd_cfg)))
  (close rd_cfg)
)
;;;=================================rest_cfg======================================

(Defun rest_dp ()

  (setq de_cfg (strcat (vl-filename-directory (findfile "delbow.lsp")) "\\" "delbow.cfg"))
  (if (= nil (findfile de_cfg))
    (progn
      (princ (strcat "\nCreating default layer settings..." "delbow.cfg\n"))
      (setq de_fh (open de_cfg "w"))
      (write-line "*** Configuration file for HVAC Duct program ***" de_fh)
      (write-line "Supply Air layer:" de_fh)
      (write-line "HVAC-SP" de_fh)
      (write-line "Supply Air layer color:" de_fh)
      (write-line "4" de_fh)
      (write-line "Supply Air Center Line layer:" de_fh)
      (write-line "HVAC-SP-CL" de_fh)
      (write-line "Supply Air Center Line layer color:" de_fh)
      (write-line "1" de_fh)
      (write-line "Supply Air Text Line layer:" de_fh)
      (write-line "HVAC-SP-TL" de_fh)
      (write-line "Supply Air Text Line layer color:" de_fh)
      (write-line "2" de_fh)
      (write-line "Supply Air Accessories layer:" de_fh)
      (write-line "HVAC-SP-AC" de_fh)
      (write-line "Supply Air Accessories layer color:" de_fh)
      (write-line "3" de_fh)
      (write-line "Exhaust Air layer:" de_fh)
      (write-line "HVAC-EX" de_fh)
      (write-line "Exhaust Air layer color:" de_fh)
      (write-line "6" de_fh)
      (write-line "Exhaust Air Center Line layer:" de_fh)
      (write-line "HVAC-EX-CL" de_fh)
      (write-line "Exhaust Air Center Line layer color:" de_fh)
      (write-line "1" de_fh)
      (write-line "Exhaust Air Text Line layer:" de_fh)
      (write-line "HVAC-EX-TL" de_fh)
      (write-line "Exhaust Air Text Line layer color:" de_fh)
      (write-line "2" de_fh)
      (write-line "Exhaust Air Accessories layer:" de_fh)
      (write-line "HVAC-EX-AC" de_fh)
      (write-line "Exhaust Air Accessories layer color:" de_fh)
      (write-line "3" de_fh)
      (write-line "End of File..." de_fh) 
      (close de_fh)
    )
  )
  (setq rd_cfg (open de_cfg "r"))
  (read-line rd_cfg) 
  (read-line rd_cfg) 
  (setq sup_lyr (read-line rd_cfg))
  (read-line rd_cfg) 
  (setq sup_clr (atoi (read-line rd_cfg)))
  (read-line rd_cfg) 
  (setq scl_lyr (read-line rd_cfg))
  (read-line rd_cfg) 
  (setq scl_clr (atoi (read-line rd_cfg)))
  (read-line rd_cfg) 
  (setq stl_lyr (read-line rd_cfg))
  (read-line rd_cfg) 
  (setq stl_clr (atoi (read-line rd_cfg)))
  (read-line rd_cfg) 
  (setq sac_lyr (read-line rd_cfg))
  (read-line rd_cfg) 
  (setq sac_clr (atoi (read-line rd_cfg)))
  (read-line rd_cfg) 
  (setq exh_lyr (read-line rd_cfg))
  (read-line rd_cfg) 
  (setq exh_clr (atoi (read-line rd_cfg)))
  (read-line rd_cfg) 
  (setq ecl_lyr (read-line rd_cfg))
  (read-line rd_cfg) 
  (setq ecl_clr (atoi (read-line rd_cfg)))
  (read-line rd_cfg) 
  (setq etl_lyr (read-line rd_cfg))
  (read-line rd_cfg) 
  (setq etl_clr (atoi (read-line rd_cfg)))
  (read-line rd_cfg) 
  (setq eac_lyr (read-line rd_cfg))
  (read-line rd_cfg) 
  (setq eac_clr (atoi (read-line rd_cfg)))
  (close rd_cfg)
)
;;;=================================*error*======================================

(defun de_err (s)

  (if (/= s "Function cancelled")
    (if (= s "quit / exit abort")
      (princ)
      (princ (strcat "\nError: " s))
    )
  )
  (if de_oer
    (setq *error* de_oer)
  )
  (if plinewid_old (setvar "plinewid"  plinewid_old))
  (if old_osnap    (setvar "osmode"    old_osnap))
  (if blipmode_old (setvar "blipmode"  blipmode_old))
  (if pickbox_old  (setvar "pickbox"   pickbox_old))
  (if text_old     (setvar "textstyle" text_old))
  (if angbase_old  (setvar "angbase"   angbase_old))
  (if lay_old      (setvar "clayer"    lay_old))
  (if col_old      (setvar "cecolor"   col_old))
  (if celtype_old  (setvar "celtype"   celtype_old))
  (redraw)
  (command "_.undo" "end")
  (if old_cmdecho  (setvar "cmdecho"   old_cmdecho))
)

(princ)
