
;;;==============================================================================
(DEFUN C:RotC (/ a b c d angl pnt1 pnt2 osn)
  
  (setq old_cmdecho  (getvar "cmdecho"))
  (setvar "cmdecho" 0)

  (setq rot_oer *error* *error* rot_err)
  
  (setq a (entsel))
  (if a
    (progn
      (setq b (entget (car a)) d (cdr a))
      (setq c (cdr (assoc 0 b)))
    )
    (setq c "")
  )
  (if (or (= c "LINE") (= c "TEXT") (= c "INSERT") (= c "CIRCLE") (= c "ARC") (= c ""))
    (progn
        (cond ((= c "LINE") (PROGN
                             (setq pnt1 (cdr (assoc 10 b)))
                             (setq pnt2 (cdr (assoc 11 b)))
                             (setq angl (angle pnt1 pnt2))
                             (setvar "snapang" angl)
                            ))
               ((or (= c "INSERT") (= c "TEXT")) (PROGN
                                 (setq angl (cdr (assoc 50 b)))
                                 (setvar "snapang" angl)                                    
                            ))
               ((= c "") (PROGN
                         (setq pnt1 (getpoint "\nPick 1st Point:  "))
                         (setq pnt2 (getpoint pnt1 "\nPick 2nd Point:  "))
                         (setq angl (angle pnt1 pnt2))
                         (setvar "snapang" angl)
                            ))
               ((or (= c "CIRCLE") (= c "ARC")) (PROGN
                             (setq pnt1 (cdr (assoc 10 b)))
                             (setq pnt2 (car d))
                             (setq angl (angle pnt1 pnt2))
                             (setvar "snapang" angl)                                    
                            ))
        )
    )
    (PROGN
      (setq pnt1 (getpoint "\nPick 1st Point:"))
      (setq pnt2 (getpoint pnt1 "\nPick 2nd Point:"))
      (setq angl (angle pnt1 pnt2))
      (setvar "snapang" angl)
    )
  )

  (setq cur_snap (* (getvar "snapang") (/ 180.0 pi)))
  (princ (strcat "\nSnapang <" (rtos cur_snap 2 2) ">"))
  (setq *error* dp_oer)
  (setvar "cmdecho"   old_cmdecho)
  (princ)
)
;;;==============================================================================

(defun dtr (bb) (/ (* pi bb) 180.0))

;;;==============================================================================

(DEFUN C:RotF ()
  (setvar "snapang" 0)
  (princ "Snapang <0>")
  (princ)
)

;;;=================================*error*======================================

(defun rot_err (s)

  (if (/= s "Function cancelled")
    (if (= s "quit / exit abort")
      (princ)
      (princ (strcat "\nError: " s))
    )
  )
  (if rot_oer
    (setq *error* rot_oer)
  )
  (if old_cmdecho (setvar "cmdecho" old_cmdecho))
)

(princ)
