// dp

dp : dialog {
   key = "dp" ;
   label = "Duct Pipe" ;
   : column {
      : row {
         : boxed_column {
            label = "Preview..." ;
         : image_button {
            allow_accept = true ;
            color = graphics_background ;
            key = "dp_image" ;
            width = 32 ;
            height = 11 ;
            is_tab_stop = false ;
         }
         }
         : column {
         : boxed_radio_row { label = "Pipe System..." ;
            : radio_button {
               key = "dp_pt1" ;
               label = "Supply" ;
               }
            spacer_1 ;
            : radio_button {
               key = "dp_pt2" ;
               label = "Exhaust" ;
               }
             }
          : row {
          : boxed_row { label = "Options..." ;
           : column {
            : row {
            : text_part {
               key = "dp_wid";
               width = 10;
            }
            : edit_box {
               edit_limit = 5 ;
               edit_width = 4 ;
               key = "dp_dia" ;
            }
            }
            : edit_box {
               edit_limit = 5 ;
               edit_width = 4 ;
               key = "dp_heg" ;
               label = "Heigth =" ;
            }
            : edit_box {
               edit_limit = 3 ;
               edit_width = 3 ;
               key = "dp_rd" ;
               label = "R/D =" ;
            }
            : edit_box {
               edit_limit = 2 ;
               edit_width = 3 ;
               key = "dp_pcs" ;
               label = "Piece =" ;
            }
          }
          spacer_1 ;
          : column {
             : text {
                key = "p_txt";
                label = "Text Heigth =" ;}
             : edit_box {
                key = "dp_txt" ;
                edit_width = 4 ;
               }
             : radio_button {
                key = "dp_txt1" ;
                label = "Round" ;}
             : radio_button {
                key = "dp_txt2" ;
                label = "Rect." ;}
               }
            }
           }
          }
         }
      : row {
         : boxed_radio_column {
            label = "Pipe Type..." ;
            : radio_button {
               key = "dp_mitered" ;
               label = "Mitered" ;
               }
            : radio_button {
               key = "dp_radius" ;
               label = "Radius" ;
               }
           }
         : boxed_column {
            label = "Pipe View..." ;
            : toggle {
               label = "Text" ;
               key = "dp_text" ;
               }
            : toggle {
               label = "Ends" ;
               key = "dp_end" ;
               }
           }
         : boxed_column {
            : toggle {
               label = "Polar" ;
               key = "dp_polar" ;
               }
            : toggle {
               label = "Piece" ;
               key = "dp_piece" ;
               }
           }
         : boxed_column {
            : toggle {
               key = "dp_opt" ;
               label = "Center line" ;
               }
            : toggle {
               key = "dp_lay" ;
               label = "Layer" ;
               }
           }
        }
        : boxed_row {
           label = "Program Settings/options" ;
               : button {
                  key = "dp_ops" ;
                  label = "Layer Options" ;
                  width = 20;
                  fixed_width = true;
                  is_tab_stop = false ;
               }
               : button {
                  key = "dp_dis" ;
                  label = "Pick a Pipe" ;
                  width = 20;
                  fixed_width = true;
                  is_tab_stop = false ;
               }
               : button {
                  key = "dp_rad" ;
                  label = "Pick a R/D" ;
                  width = 20;
                  fixed_width = true;
                  is_tab_stop = false ;
               }
            }
          }
   : text {
      alignment = centered ;
      label = "May 2003" ;
   }
   : text {
      alignment = centered ;
      label = "Programmed by Anton Jemeldjazev" ;
   }
   ok_cancel ;
}


// dp layer

dp_opt : dialog {
  label = "Duct Elbow Layer Optins" ;
 : row {
  : column {
   : boxed_row {
       label = "Supply Air Layer Settings..." ;
    : column {
    : edit_box {
         label = "Supply Air: " ;
         key = "dp_sup" ;
         edit_width = 11 ;}
    : edit_box {
         label = "Supply Air Center line: " ;
         key = "dp_scl" ;
         edit_width = 11 ;}
    : edit_box {
         label = "Supply Air Text: " ; 
         key = "dp_stl" ;
         edit_width = 11 ;}
    : edit_box {
         label = "Supply Air Accessories:  " ; 
         key = "dp_sac" ;
         edit_width = 11 ;}
         }
    : column {
    : button {
         label = "Set Color" ;
         key = "dp_sup_clr" ;
         fixed_width = true ;
         width = 10 ;}
    : button {
         label = "Set Color" ;
         key = "dp_scl_clr" ;
         fixed_width = true ;
         width = 10 ;}
    : button {
         label = "Set Color" ;
         fixed_width = true ;
         key = "dp_stl_clr" ;
         width = 10 ;}
    : button {
         label = "Set Color" ;
         fixed_width = true ;
         key = "dp_sac_clr" ;
         width = 10 ;}
         }
    : column {
    : edit_box {
         key = "sup_clr" ;
         fixed_width = true ;
         edit_width = "3" ;}
    : edit_box {
         key = "scl_clr" ;
         fixed_width = true ;
         edit_width = "3" ;}
    : edit_box {
         key = "stl_clr" ;
         fixed_width = true ;
         edit_width = "3" ;}
    : edit_box {
         key = "sac_clr" ;
         fixed_width = true ;
         edit_width = "3" ;}
         }
    : column {
    : image {
         key = "sup_box" ;
         fixed_width = true ;
         width = 2 ;
         height = 1 ;}
    : image {
         key = "scl_box" ;
         fixed_width = true ;
         width = 2 ;
         height = 1 ;}
    : image {
         key = "stl_box" ;
         fixed_width = true ;
         width = 2 ;
         height = 1 ;}
    : image {
         key = "sac_box" ;
         fixed_width = true ;
         width = 2 ;
         height = 1 ;}
         }
    }       
    :boxed_row {
          label = "Exhaust Air Layer Settings..." ;
    : column {
    : edit_box {
         label = "Exhaust Air: " ;
         key = "dp_exh" ;
         edit_width = 11 ;}
    : edit_box {
         label = "Exhaust Air Center line: " ;
         key = "dp_ecl" ;
         edit_width = 11 ;}
    : edit_box {
         label = "Exhaust Air Text: " ;
         key = "dp_etl" ;
         edit_width = 11 ;}
    : edit_box {
         label = "Exhaust Air Accessories:" ;
         key = "dp_eac" ;
         edit_width = 11 ;}
         }
    : column {
	: button {
            label = "Set Color" ;
            key = "dp_exh_clr" ;
            fixed_width = true ;
            width = 10 ;}
	: button {
            label = "Set Color" ;
            fixed_width = true ;
            key = "dp_ecl_clr" ;
            width = 10 ;}
	: button {
            label = "Set Color" ;
            key = "dp_etl_clr" ;
            fixed_width = true ;
            width = 10 ;}
    : button {
            label = "Set Color" ;
            key = "dp_eac_clr" ;
            fixed_width = true ;
            width = 10 ;}
    }
    : column {
	: edit_box {
            key = "exh_clr" ;
            fixed_width = true ;
            edit_width = "3" ;}
	: edit_box {
            key = "ecl_clr" ;
            fixed_width = true ;
            edit_width = "3" ;}
	: edit_box {
            key = "etl_clr" ;
            fixed_width = true ;
            edit_width = "3" ;}
    : edit_box {
            key = "eac_clr" ;
            fixed_width = true ;
            edit_width = "3" ;}
    }
    : column {
	: image {
            key = "exh_box" ;
            fixed_width = true ;
            width = 2 ;
            height = 1 ;}
	: image {
            key = "ecl_box" ;
            fixed_width = true ;
            width = 2 ;
            height = 1 ;}
	: image {
            key = "etl_box" ;
            fixed_width = true ;
            width = 2 ;
            height = 1 ;}
        : image {
            key = "eac_box" ;
            fixed_width = true ;
            width = 2 ;
            height = 1 ;}
   }
  }
 }
}
spacer_1;
: row {
: button {
        key = "dp_sav";
        width = 19;
        fixed_width = true;
        is_default = true;
        label = "Save Changes";}
: button {
        key = "dp_can";
        width = 19;
        fixed_width = true;
        label = "Cancel Changes";}
}
   : text {
      alignment = centered ;
      label = "May 2003" ;
   }
   : text {
      alignment = centered ;
      label = "Programmed by Anton Jemeldjazev" ;
   }
}
